
/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */
 
function CHideDbItem(id, radioId, divId, divSwitcher, objSwitcher)
{
	this.Id = id;
    this._radio = document.getElementById(radioId);
    this._div = document.getElementById(divId);
    this._divSwitcher = document.getElementById(divSwitcher);
    this._objSwitcher = objSwitcher;
    
    this.Checked = function ()
    {
    	if (this._radio == null) return false;
    	return this._radio.checked;
    };
    
    this.MakeActive = function ()
    {
    	if (this._div == null) return;
    	this._SetDisabled(false);
    };

    this.MakePassive = function ()
    {
    	if (this._div == null) return;
    	this._SetDisabled(true);
    };
    
    this._SetDisabled = function (bValue)
    {
    	this._div.className = (bValue) ? '' : 'activ';
    	
    	if (!bValue) {
    		this._divSwitcher.appendChild(this._objSwitcher);
    	}
    };

	if (this._radio == null) return;
    this._radio.onclick = function ()
    {
    	if (this.checked)
    		wmDbSettings.SetMode(id);
    };
}

var wmDbSettings = {
	Constants: {
		MSSQL: 0,
		MySQL: 1
	},
	_mode: 0,
	_items: Array(),
	_body: null,
	
	Init: function ()
	{
		var obj = this;
		var consts = this.Constants;
		this._body = document.getElementById('dbSwitcher');
	    this._items[consts.MSSQL] = new CHideDbItem(consts.MSSQL, 'intDbType0', 'divMSSQL', 'divMSSQLdbSwitcher', this._body);
	    this._items[consts.MySQL] = new CHideDbItem(consts.MySQL, 'intDbType1', 'divMySQL', 'divMySQLdbSwitcher', this._body);
		
		var iCount = this._items.length;
		for (var i=0; i<iCount; i++) {
			var item = this._items[i];
			if (item.Checked()) {
				item.MakeActive();
				this._mode = item.Id;
			} else {
				item.MakePassive();
			}
		}
		
		this.csSwitcher = document.getElementById("useCS");
		this.csSwitcherChild = document.getElementById("odbcConnectionString");
		
		if (this.csSwitcher && this.csSwitcherChild){
			this.csSwitcher.onchange = function() {
				obj.InitForm(1);
			}				
		}
		
		this.InitForm();
	},
	
	SetMode: function (mode)
	{
		var iCount = this._items.length;
		for (var i=0; i<iCount; i++) {
			var item = this._items[i];
			if (item.Id == mode) {
				item.MakeActive();
			}
			else {
				item.MakePassive();
			}
		}
	},
	
	InitForm: function (svalue)
	{
		svalue = (svalue == undefined) ? 0: svalue;
		
		if ((svalue == 1 || svalue == 0) && this.csSwitcher && this.csSwitcherChild){
			SetDisabled(this.csSwitcherChild, !(this.csSwitcher.checked));
		}
	}
};

var wmWebMailSettings = {
	
	Init: function ()
	{
		var obj = this;
		this.protocolSwitcher = document.getElementById("intIncomingMailProtocol");
		this.protocolPort = document.getElementById("intIncomingMailPort");
		if (this.protocolSwitcher && this.protocolPort){
			Validator.RegisterAllowNum(this.protocolPort);
			this.protocolSwitcher.onchange = function() {
				obj.InitForm(1);
			}				
		}
		
		var outPort = document.getElementById("intOutgoingMailPort");
		if (outPort){
			Validator.RegisterAllowNum(outPort);
		}
		
		var aSizeLimit = document.getElementById("intAttachmentSizeLimit");
		if (aSizeLimit){
			Validator.RegisterAllowNum(aSizeLimit);
		}
		var mSizeLimit = document.getElementById("intMailboxSizeLimit");
		if (mSizeLimit){
			Validator.RegisterAllowNum(mSizeLimit);
		}
		
		this.dmSwitcher = document.getElementById("intAllowDirectMode");
		this.dmSwitcherChild = document.getElementById("intDirectModeIsDefault");
		if (this.dmSwitcher && this.dmSwitcherChild){
			this.dmSwitcher.onchange = function() {
				obj.InitForm(2);
			}				
		}
		
		this.attachSwitcher = document.getElementById("intEnableAttachSizeLimit");
		this.attachSwitcherChild = document.getElementById("intAttachmentSizeLimit");
		if (this.attachSwitcher && this.attachSwitcherChild){
			this.attachSwitcher.onchange = function() {
				obj.InitForm(3);
			}				
		}
		
		this.mailBoxSwitcher = document.getElementById("intEnableMailboxSizeLimit");
		this.mailBoxSwitcherChild = document.getElementById("intMailboxSizeLimit");
		if (this.mailBoxSwitcher && this.mailBoxSwitcherChild){
			this.mailBoxSwitcher.onchange = function() {
				obj.InitForm(4);
			}				
		}
		
		this.InitForm();
	},
	
	InitForm: function (svalue)
	{
		svalue = (svalue == undefined) ? 0: svalue;
		
		if ((svalue == 1) && this.protocolSwitcher && this.protocolPort){
			if (this.protocolSwitcher.value == 0) {
				this.protocolPort.value = '110';
			} else if (this.protocolSwitcher.value == 1) {
				this.protocolPort.value = '143';
			}
		}
		
		if ((svalue == 2 || svalue == 0) && this.dmSwitcher && this.dmSwitcherChild){
			if (this.dmSwitcher.checked) {
				SetDisabled(this.dmSwitcherChild, false);
			} else {
				this.dmSwitcherChild.checked = false;
				SetDisabled(this.dmSwitcherChild, true);
			}
		}
		if ((svalue == 3 || svalue == 0) && this.attachSwitcher && this.attachSwitcherChild){
			SetDisabled(this.attachSwitcherChild, !(this.attachSwitcher.checked));
		}
		if ((svalue == 4 || svalue == 0) && this.mailBoxSwitcher && this.mailBoxSwitcherChild){
			SetDisabled(this.mailBoxSwitcherChild, !(this.mailBoxSwitcher.checked));
		}
	}
};

function CHideLoginItem(id, radioId, divId)
{
	this.Id = id;
    this._radio = document.getElementById(radioId);
    this._div = document.getElementById(divId);
    
    this.Checked = function ()
    {
    	if (this._radio == null) return false;
    	return this._radio.checked;
    };
    
    this.MakeActive = function ()
    {
    	if (this._div == null) return;
    	this._SetDisabled(false);
    };

    this.MakePassive = function ()
    {
    	if (this._div == null) return;
    	this._SetDisabled(true);
    };
    
    this._SetDisabled = function (bValue)
    {
    	this._div.className = (bValue) ? '' : 'activ';
    	var inputs = this._div.getElementsByTagName("INPUT");
    	var selects = this._div.getElementsByTagName("SELECT");
    	var i, c;
    	for (i = 1, c = inputs.length; i < c; i++)
    	{
    		SetDisabled(inputs[i], bValue);
    	}
    	for (i = 0, c = selects.length; i < c; i++)
    	{
    		SetDisabled(selects[i], bValue);
    	}
    }

	if (this._radio == null) return;
    this._radio.onclick = function ()
    {
    	if (this.checked)
    		wmLoginSettings.SetMode(id);
    };
}

var wmLoginSettings = {
	Constants: {
		StandardLogin: 0,
		HideLogin: 1,
		HideEmail: 2
	},
	_mode: 0,
	_items: Array(),
	
	Init: function ()
	{
		var consts = this.Constants;
	    this._items[consts.StandardLogin] = new CHideLoginItem(consts.StandardLogin, 'hideLoginRadionButton1', 'hideLoginDiv1');
	    this._items[consts.HideLogin] = new CHideLoginItem(consts.HideLogin, 'hideLoginRadionButton2', 'hideLoginDiv2');
	    this._items[consts.HideEmail] = new CHideLoginItem(consts.HideEmail, 'hideLoginRadionButton3', 'hideLoginDiv3');
		
		var iCount = this._items.length;
		for (var i=0; i<iCount; i++) {
			var item = this._items[i];
			if (item.Checked()) {
				item.MakeActive();
				this._mode = item.Id;
			} else {
				item.MakePassive();
			}
		}
	},
	
	SetMode: function (mode)
	{
		var iCount = this._items.length;
		for (var i=0; i<iCount; i++) {
			var item = this._items[i];
			if (item.Id == mode) {
				item.MakeActive();
			}
			else {
				item.MakePassive();
			}
		}
	}
};





var SettingsObjects = Array();
SettingsObjects['db'] = wmDbSettings;
SettingsObjects['webmail'] = wmWebMailSettings;
SettingsObjects['login'] = wmLoginSettings;
/*
SettingsObjects['cal'] = wmCalSettings;
*/