/*
* CTimeSelector
* CCalendarTable
* CSharingForm
*/
var timeFormat1 = [
	{Id:0,		Value:"12 AM"},
	{Id:0.5,	Value:"12:30 AM"},
	{Id:1,		Value:"1 AM"},
	{Id:1.5,	Value:"1:30 AM"},
	{Id:2,		Value:"2 AM"},
	{Id:2.5,	Value:"2:30 AM"},
	{Id:3,		Value:"3 AM"},
	{Id:3.5,	Value:"3:30 AM"},
	{Id:4,		Value:"4 AM"},
	{Id:4.5,	Value:"4:30 AM"},
	{Id:5,		Value:"5 AM"},
	{Id:5.5,	Value:"5:30 AM"},
	{Id:6,		Value:"6 AM"},
	{Id:6.5,	Value:"6:30 AM"},
	{Id:7,		Value:"7 AM"},
	{Id:7.5,	Value:"7:30 AM"},
	{Id:8,		Value:"8 AM"},
	{Id:8.5,	Value:"8:30 AM"},
	{Id:9,		Value:"9 AM"},
	{Id:9.5,	Value:"9:30 AM"},
	{Id:10,		Value:"10 AM"},
	{Id:10.5,	Value:"10:30 AM"},
	{Id:11,		Value:"11 AM"},
	{Id:11.5,	Value:"11:30 AM"},
	{Id:12,		Value:"12 PM"},
	{Id:12.5,	Value:"12:30 PM"},
	{Id:13,		Value:"1 PM"},
	{Id:13.5,	Value:"1:30 PM"},
	{Id:14,		Value:"2 PM"},
	{Id:14.5,	Value:"2:30 PM"},
	{Id:15,		Value:"3 PM"},
	{Id:15.5,	Value:"3:30 PM"},
	{Id:16,		Value:"4 PM"},
	{Id:16.5,	Value:"4:30 PM"},
	{Id:17,		Value:"5 PM"},
	{Id:17.5,	Value:"5:30 PM"},
	{Id:18,		Value:"6 PM"},
	{Id:18.5,	Value:"6:30 PM"},
	{Id:19,		Value:"7 PM"},
	{Id:19.5,	Value:"7:30 PM"},
	{Id:20,		Value:"8 PM"},
	{Id:20.5,	Value:"8:30 PM"},
	{Id:21,		Value:"9 PM"},
	{Id:21.5,	Value:"9:30 PM"},
	{Id:22,		Value:"10 PM"},
	{Id:22.5,	Value:"10:30 PM"},
	{Id:23,		Value:"11 PM"},
	{Id:23.5,	Value:"11:30 PM"},
	{Id:24,		Value:"12 AM"}
];

var timeFormat2 = [
	{Id:0,		Value:"00:00"},
	{Id:0.5,	Value:"00:30"},
	{Id:1,		Value:"01:00"},
	{Id:1.5,	Value:"01:30"},
	{Id:2,		Value:"02:00"},
	{Id:2.5,	Value:"02:30"},
	{Id:3,		Value:"03:00"},
	{Id:3.5,	Value:"03:30"},
	{Id:4,		Value:"04:00"},
	{Id:4.5,	Value:"04:30"},
	{Id:5,		Value:"05:00"},
	{Id:5.5,	Value:"05:30"},
	{Id:6,		Value:"06:00"},
	{Id:6.5,	Value:"06:30"},
	{Id:7,		Value:"07:00"},
	{Id:7.5,	Value:"07:30"},
	{Id:8,		Value:"08:00"},
	{Id:8.5,	Value:"08:30"},
	{Id:9,		Value:"09:00"},
	{Id:9.5,	Value:"09:30"},
	{Id:10,		Value:"10:00"},
	{Id:10.5,	Value:"10:30"},
	{Id:11,		Value:"11:00"},
	{Id:11.5,	Value:"11:30"},
	{Id:12,		Value:"12:00"},
	{Id:12.5,	Value:"12:30"},
	{Id:13,		Value:"13:00"},
	{Id:13.5,	Value:"13:30"},
	{Id:14,		Value:"14:00"},
	{Id:14.5,	Value:"14:30"},
	{Id:15,		Value:"15:00"},
	{Id:15.5,	Value:"15:30"},
	{Id:16,		Value:"16:00"},
	{Id:16.5,	Value:"16:30"},
	{Id:17,		Value:"17:00"},
	{Id:17.5,	Value:"17:30"},
	{Id:18,		Value:"18:00"},
	{Id:18.5,	Value:"18:30"},
	{Id:19,		Value:"19:00"},
	{Id:19.5,	Value:"19:30"},
	{Id:20,		Value:"20:00"},
	{Id:20.5,	Value:"20:30"},
	{Id:21,		Value:"21:00"},
	{Id:21.5,	Value:"21:30"},
	{Id:22,		Value:"22:00"},
	{Id:22.5,	Value:"22:30"},
	{Id:23,		Value:"23:00"},
	{Id:23.5,	Value:"23:30"},
	{Id:24,		Value:"24:00"}
];

function CTimeSelector (timeSelector_id,thisTime,fromTime)
{
	this.container = null;
	this.parentObj = null;
	this.settingsTimeFormat = null;
	this.timeSelector_id = timeSelector_id;
	this.startOptionNumber = 0;
	this.Initialize(thisTime,fromTime);
}
 
CTimeSelector.prototype = {
	Initialize: function(thisTime,fromTime)
	{
		this.container = $(this.timeSelector_id);
		this.container.className = 'wm_hide';
		this.settingsTimeFormat = setcache['timeformat'];

		var div1, timeOptions, pattern, startOptionValue;

		if (this.settingsTimeFormat == 1) {
			pattern = /^1?[0-9](:[03]0)?(\s+(AM|PM))$/;
			timeOptions = timeFormat1;
			this.container.style.textAlign = "left";
			this.container.style.paddingLeft = "4px";
		} else {
			pattern = /^([0-2])?[0-9](:[03]0)$/;
			timeOptions = timeFormat2;
		}

		if (fromTime != null && pattern.test(fromTime)) {
			startOptionValue = fromTime;
		} else {
			startOptionValue = null;
		}

		var len = (this.timeSelector_id=="EventTimeFrom_dropdown")?(timeOptions.length-1):timeOptions.length;
		for (i=0; i<len; i++) {
			if (startOptionValue != null) {
				if (startOptionValue == timeOptions[i].Value) {this.startOptionNumber = i+1;};
				if ( i<this.startOptionNumber || this.startOptionNumber == 0) continue;
			};

			div1 = document.createElement('div');
			div1.className	= 'ts_text';
			div1.innerHTML	= timeOptions[i].Value;
			div1.onmouseover= function () { this.className = 'ts_text_hover'; };
			div1.onmouseout	= function () { this.className = 'ts_text'; };
			var timeObj		= {Id:timeOptions[i].Id, Value:timeOptions[i].Value};
			div1.onclick	= CreateTimeFunc(this, timeObj);

			if (thisTime == timeOptions[i].Value) div1.style.fontWeight = "bold";
			this.container.appendChild(div1);

		}
	},

	Show: function (obj, event)
	{
		this.StopEvents(event);
		this.parentObj = obj;
		this.container.className = 'time_selector';
		this.container.style.position = 'absolute';
		this.container.style.zIndex = '2001';
		this.container.scrollTop = this.ScrollValue(obj);
	},

	Hide: function ()
	{
		this.container.className = 'wm_hide';
	},

	ScrollValue : function(obj)
	{
		var timeOptions, v = 0; //vertical offset
		var ThisTime = Trim(obj.value);

		if (this.settingsTimeFormat == 1) {
			timeOptions = timeFormat1;
		} else {
			timeOptions = timeFormat2;
		};

		var len = (this.timeSelector_id=="EventTimeFrom_dropdown")?(timeOptions.length-1):timeOptions.length;
		for (var i=this.startOptionNumber; i<len; i++)
		{
			if (ThisTime == timeOptions[i].Value) return (v*16); //16-height of 1 option
			v++;
		}
	},

	StopEvents: function(event)
	{
		var event = event || window.event;
		if (event.stopPropagation) {
			event.stopPropagation();
		} else {
			event.cancelBubble = true;
		}
	},

	Remove: function()
	{
		CleanNode(this.container);
	}
};

function CreateTimeFunc(obj, timeObj)
{ 
	return function () {
		obj.Hide();
		obj.onpicktime(timeObj);
	}
}

//start_print_time - optional
// if start_print_time == mull then timetill list starts from 00:00 or 12AM
function CreateTimeTill(till_time, start_print_time)
{
	var timetill_id = "EventTimeTill_dropdown";
	timeSelectorTill = new CTimeSelector(timetill_id, till_time, start_print_time);
	var input_timeFrom = $('EventTimeFrom');
	var input_timeTill = $('EventTimeTill');

	timeSelectorTill.onpicktime = function(timeObj)
	{
		input_timeTill.value = timeObj.Value;
		timeSelectorTill.Remove();
		CreateTimeTill(input_timeTill.value,Trim(input_timeFrom.value));
	};
	input_timeTill.onfocus = function(event) {
		if (typeof(calendarTableStart) != 'undefined') calendarTableStart.Hide();
		if (typeof(calendarTableEnd) != 'undefined') calendarTableEnd.Hide();
		timeSelectorTill.Hide();
		timeSelectorTill.Show(this, event)
	}
}

function CreateTimeFrom(from_time)
{
	var timefrom_id = "EventTimeFrom_dropdown";
	timeSelectorFrom = new CTimeSelector(timefrom_id, from_time);
	var input_timeFrom = $('EventTimeFrom');
	var input_timeTill = $('EventTimeTill');
	var input_dateFrom = $('EventDateFrom');
	var input_dateTill = $('EventDateTill');
	
	timeSelectorFrom.onpicktime = function(timeObj)
	{
		var tillTimeValue, tillTimeId, timeOptions, startTimeTill = null;

		if(setcache['timeformat'] == 1){
			pattern = /^1?[0-9](:[03]0)?(\s+(AM|PM))$/;
			timeOptions = timeFormat1;
		} else {
			pattern = /^([0-2])?[0-9](:[03]0)$/;
			timeOptions = timeFormat2;
		};
		//check time till value in input field
		if (pattern.test(Trim(input_timeTill.value))) {
			tillTimeValue = Trim(input_timeTill.value);
			for (i=0; i<timeOptions.length; i++) {
				if (tillTimeValue == timeOptions[i].Value) {
					tillTimeId = timeOptions[i].Id;
					break;
				}
			}
		} else {
			tillTimeId = (timeObj.Id + 1);
			for (i=0; i<timeOptions.length; i++) {
				if (tillTimeId == timeOptions[i].Id) {
					tillTimeValue = timeOptions[i].Value;
					break;
				}
			}
		};
		startTimeTill = timeObj.Value;

		if (tillTimeId<=timeObj.Id) {
			//check date values
			var dateFrom = ConvertFromStrToDate(Trim(input_dateFrom.value));
			var dateTill = ConvertFromStrToDate(Trim(input_dateTill.value));

			//redefine date values if it's wrong
			if (dateFrom == null) {
				dateFrom = (dateTill == null)? (new Date()) : dateTill;
			};
			if (dateTill == null) {
				dateTill = (dateFrom == null)? (new Date()) : dateFrom;
			};

			//define time till value
			for (i=0; i<timeOptions.length; i++) {
				if (timeObj.Value == timeOptions[i].Value) {
					tillTimeValue = timeOptions[i+1].Value;
					break;
				}
			};
			if (dateFrom.getTime() >= dateTill.getTime()) {
				input_dateTill.value = ConvertFromDateToStr(dateFrom);
			} else {
				startTimeTill = null;
			}
		};

		input_timeFrom.value = timeObj.Value;
		input_timeTill.value = tillTimeValue; 

		timeSelectorTill.Remove();
		CreateTimeTill(tillTimeValue, startTimeTill);

		timeSelectorFrom.Remove();
		CreateTimeFrom(timeObj.Value);
	};
	input_timeFrom.onfocus = function(evt) {
		var evt = (evt)?evt:window.event;
		var tgt = window.event ? window.event.srcElement : evt.target;
		var select_box_list = $('edit_select_box_list');
		if (tgt.id != 'calen_sal' && tgt.id != 'calendar_arrow' && select_box_list.style.display != 'none'){
			select_box_list.style.display = 'none';
		};
		if (typeof(calendarTableStart) != 'undefined') calendarTableStart.Hide();
		if (typeof(calendarTableEnd) != 'undefined') calendarTableEnd.Hide();
		timeSelectorTill.Hide();
		timeSelectorFrom.Show(this, evt);
	}
}

var all_events_dates = new Array();

function CCalendarTable (parent)
{
	this.WeekDaysNames = [
		Lang.CalendarTableDayMonday,
		Lang.CalendarTableDayTuesday,
		Lang.CalendarTableDayWednesday,
		Lang.CalendarTableDayThursday,
		Lang.CalendarTableDayFriday,
		Lang.CalendarTableDaySaturday,
		Lang.CalendarTableDaySunday
	];
	this.m_names = [
		Lang.FullMonthJanuary,
		Lang.FullMonthFebruary,
		Lang.FullMonthMarch,
		Lang.FullMonthApril,
		Lang.FullMonthMay,
		Lang.FullMonthJune,
		Lang.FullMonthJuly,
		Lang.FullMonthAugust,
		Lang.FullMonthSeptember,
		Lang.FullMonthOctober,
		Lang.FullMonthNovember,
		Lang.FullMonthDecember
	];
	this.dms = 86400000; // 86400000 milliseconds in one day
	this.weeksnum = 7;

	this.SelectedDate		= null;
	this.HtmlContainer		= null;
	this.prevMonthSwitcher	= null;
	this.nextMonthSwitcher	= null;
	this.middleTdSelector	= null;
	this.monthsList			= null;
	this.currentMonth		= null;

	if (parent) {
		this.Create(parent);
		//this.SetDateFromPicker = function (day,month,year) { }
	} else {
		this.Create(document.body);
		this.SetDateFromPicker = function (day,month,year) { this.Hide(); }
	}
}

CCalendarTable.prototype = {
	//Show Calendar after onClick on img
	Create: function (parent)
	{
		this.HtmlContainer = CreateChild(parent, 'div');
		this.HtmlContainer.className = 'wm_hide';

		date = new Date();
		all_events_dates = LoadAllYearEvents(date);

		// create TABLE
		var m = CreateChild(this.HtmlContainer, 'table');
		m.className = 'Calendar_Title';
		var m_tr_2 = m.insertRow(0);
		var m_td_21 = m_tr_2.insertCell(0);
		var m_td_22 = m_tr_2.insertCell(1);
		var m_td_23 = m_tr_2.insertCell(2);

		m_td_21.style.width = '32px';
		m_td_21.style.textAlign = 'right';

		m_td_23.style.width = '32px';
		m_td_23.style.textAlign = 'left';

		m_td_22.style.textAlign = 'center';
		m_td_22.style.width = '120px';
		m_td_22.style.zIndex = '15'; 
		m_td_22.style.display = 'block';
		m_td_22.style.position = 'relative';

		// Month Row
		var obj = this;
		this.prevMonthSwitcher = CreateChild(m_td_21, 'a');
		this.prevMonthSwitcher.href = 'javascript:void(0);';
		var img = CreateChild(this.prevMonthSwitcher, 'img');
		img.alt = Lang.AltPrevMonth;
		img.title = Lang.AltPrevMonth;
		img.style.border = '0';
		img.src = './calendar/skins/calendar/minicalendar_arrow_left_activ.gif';
		img.style.width = "11px";
		img.style.height = "11px";

		// td_middle_place
		var middleTdSelector_ = document.createElement("div");
		middleTdSelector_.className = 'middleTdSelector_';
		this.middleTdSelector = document.createElement("div");
		this.middleTdSelector.id = "middleTdSelector";
		this.middleTdSelector.className = 'middleTdSelector';

		this.currentMonth = document.createElement("span");
		this.currentMonth.id = "MonthSelector";
		this.middleTdSelector.appendChild(this.currentMonth);

		var imgSelector = document.createElement("img");
		imgSelector.id = "imgSelector";
		imgSelector.alt = '';
		imgSelector.style.border = '0';
		imgSelector.src = './calendar/skins/calendar/minicalendar_arrow_bottom.gif';
		imgSelector.style.padding = '0 0 0 4px';
		imgSelector.style.width = "11px";
		imgSelector.style.height = "7px";

		this.middleTdSelector.onmouseover = function() {
			//imgSelector.src = './calendar/skins/calendar/minicalendar_arrow_bottom_activ.gif';
			obj.middleTdSelector.className = 'middleTdSelector_over';
		};
		this.middleTdSelector.onmouseout = function() {
			//imgSelector.src = './calendar/skins/calendar/minicalendar_arrow_bottom.gif';
			if (obj.monthsList.hidden) {
				obj.middleTdSelector.className = 'middleTdSelector';
			}
		};
		this.middleTdSelector.appendChild(imgSelector);
		middleTdSelector_.appendChild(this.middleTdSelector);
		m_td_22.appendChild(middleTdSelector_);

		this.monthsList = document.createElement("div");
		this.monthsList.id = "monthsList";
		this.monthsList.className = "event edit_gray monthsList";
		this.monthsList.hidden = true;
		this.middleTdSelector.onclick = function() {
			if(obj.monthsList.hidden) {
				obj.monthsList.style.display = 'block';
			} else {
				obj.monthsList.style.display = 'none';
			};
			obj.monthsList.hidden = !obj.monthsList.hidden;
		};

		for (i=-6; i<7; i++) {
			evt_middle = document.createElement("div");
			evt_middle.className = 'event_middle';
			var cal_txt = document.createElement("div");
			cal_txt.className = 'calendar_text';
			txt = document.createElement("span");
			txt.className = 'text';

			a = document.createElement("a");
			a.href = 'javascript:void(0);';
			a.id = "dd_month_"+i;

			txt.appendChild(a);
			cal_txt.appendChild(txt);
			evt_middle.appendChild(cal_txt);
			this.monthsList.appendChild(evt_middle);
		};
		var tempDiv = document.createElement("div");
		tempDiv.className = 'c';
		tempDiv.height = "1px !important";
		this.monthsList.appendChild(tempDiv);
		tempDiv = document.createElement("div");
		tempDiv.className = 'a';
		this.monthsList.appendChild(tempDiv);

		m_td_22.appendChild(this.monthsList);


//td_middle_place_end
		this.nextMonthSwitcher = document.createElement("a");
		this.nextMonthSwitcher.href = 'javascript:void(0);';
		img = CreateChild(this.nextMonthSwitcher, 'img');
		img.alt = Lang.AltNextMonth;
		img.title = Lang.AltNextMonth;
		img.style.border = '0';
		img.src = './calendar/skins/calendar/minicalendar_arrow_right_activ.gif';
		img.style.width = "11px";
		img.style.height = "11px";

		m_td_23.appendChild(this.nextMonthSwitcher);

		var Table = CreateChild(this.HtmlContainer, 'table');
		Table.cellPadding = '0';
		Table.cellSpacing = '0';
		Table.valign = 'middle';
		Table.className = 'calendar_block';

		var TR = Table.insertRow(0);
		TR.id = "calendarWeekdayHeaders";
		for(wd = 0; wd < 7; wd++)
		{
			var TD = TR.insertCell(wd);
			TD.className = 'title';
		};

		for(w = 1; w <= this.weeksnum; w++){
			var TR = Table.insertRow(w);
			TR.id = "sc_week_"+w;
			for(k = 1; k<=7; k++){
				var TD = TR.insertCell(-1);
				TD.valign = 'middle';
			}
		};

	},

	Show: function (obj)
	{
		this.HtmlContainer.className = 'box';
		if (obj) {
			var bounds = GetBounds(obj);
			with (this.HtmlContainer.style) {
				position = 'absolute';
				top = bounds.Top + bounds.Height + 'px';
				left = bounds.Left + 1 + 'px';
				zIndex = '21';
			}
		}
	},

	Hide: function ()
	{
		this.HtmlContainer.className = 'wm_hide';
	},

	//Return days in month
	GetDaysInMonth: function (month,year)
	{
		month = ( month<1 ) ? 0 : (( month>12 ) ? 11 : month - 1);
		var arDaysInMonth_Usual = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		var arDaysInMonth_Leap 	= [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		if ( (year % 4) == 0 && (year % 100) != 0 || (year % 400) == 0 ) 
			return arDaysInMonth_Leap[month];
		else
			return arDaysInMonth_Usual[month];
	},

	// Return day in week: 0 - Mo, 1 - Tu ...
	GetDay: function ( cDate )
	{
		var wDay = cDate.getDay() - 1;
		if ( wDay == -1 ) wDay = 6;
		return wDay;
	},

	GetWeeksNum: function ( firstshowdayDate, lastshowdayDate )
	{
		var weeksnum = Math.ceil(((lastshowdayDate - firstshowdayDate) / this.dms) / 7);
		return weeksnum;
	},

	RefreshCalendarSelector: function(day,month,year) //fill calendar with new data
	{
		var todayDate = new Date();
		var obj = this;

		// checking input data
		if( month == 0 || day == 0 || year == 0 )
		{
			month = todayDate.getMonth()+1;
			day = todayDate.getDate();
			year = todayDate.getFullYear();
		};
		// For Previous Month
		var PM_prev_month = month -1;
		var PM_prev_year = year;
		if (PM_prev_month == 0)
		{
			PM_prev_month = 12;
			PM_prev_year = year -1;
		};
		// For Next Month
		var NM_next_month = Number(month) +1;
		var NM_next_year = year;
	    
		if (NM_next_month == 13)
		{
			NM_next_month = 1;
			NM_next_year = Number(year) + 1;
		};

		//Define drop down select
		this.prevMonthSwitcher.onclick = CreateChangeMonthFunc(obj, PM_prev_month, PM_prev_year);
		this.nextMonthSwitcher.onclick = CreateChangeMonthFunc(obj, NM_next_month, NM_next_year);
		this.currentMonth.innerHTML = this.m_names[month - 1] + '&nbsp;' + year + '&nbsp;';

		var k=0, m_num, evt_middle, cal_txt, txt;
		for (i=-6; i<7; i++) {
			a = $("dd_month_"+i);
			m_num = Number(month)-1 + i;
			if (m_num<0) {
				a.onclick = CreateChangeMonthFunc(obj, (12 + m_num + 1), (year-1));
				a.innerHTML = this.m_names[12 + m_num] +  '&nbsp;' + (year-1);
			}
			else if (m_num>=0 && m_num<=11) {
				a.onclick = CreateChangeMonthFunc(obj, (m_num+1), year);
				if ((m_num+1) == Number(month)) a.style.fontWeight = 'bold';
				a.innerHTML = this.m_names[m_num] +  '&nbsp;' + year;
			}
			else {
				a.onclick = CreateChangeMonthFunc(obj, (k+1), (year+1));
				a.innerHTML = this.m_names[k] +  '&nbsp;' + (year+1);
				k++;
			}
		};

		//fill calendar table headers with values of week days
		var tdHeaders = $('calendarWeekdayHeaders').getElementsByTagName("td");
		for(i = 0; i<tdHeaders.length; i++)
		{
			if (setcache['weekstartson'] == 0) {
				tdHeaders[i].innerHTML = (i==0)?this.WeekDaysNames[6]:this.WeekDaysNames[i-1];	
			} else {
				tdHeaders[i].innerHTML = this.WeekDaysNames[i]; // 'Mo','Tu','We','Th','Fr','Sa','Su'
			}
		};

		//Define days in calendar table
		var days_in_month = this.GetDaysInMonth(month,year);
		month = month - 1;

		var mDate = new Date(year,month,day);
		//load _alladys_events
		if (year != todayDate.getFullYear() && (month == 11 || month == 0)) {
			var new_dates = LoadAllYearEvents(mDate);
			for (i in new_dates) {
				if (all_events_dates[i] == undefined) all_events_dates[i] = true;
			}
		};

		var firstdayDate = new Date(mDate.getFullYear(),mDate.getMonth(),1); // first day of month

		var lastdayDate = new Date(mDate.getFullYear(),mDate.getMonth(),days_in_month);	// last day of month
		var firstshowdayDate = firstdayDate.setTime(firstdayDate.getTime() - this.dms * this.GetDay(firstdayDate)); //in millisecconds
		var lastshowdayDate  = lastdayDate.setTime(lastdayDate.getTime() + (this.dms * ( 6 - this.GetDay(lastdayDate) ))); //in milliseconds

		this.weeksnum = this.GetWeeksNum(firstshowdayDate, lastshowdayDate);
		var firstAddWeeks;
		var lastAddWeeks;
		switch (this.weeksnum)
		{
			case 4:
				firstAddWeeks = 1;
				lastAddWeeks  = 2;
				break;
			case 5:
				firstAddWeeks = 1;
				lastAddWeeks  = 1;
				break;
			case 6:
				firstAddWeeks = 0;
				lastAddWeeks  = 1;
				break;
			default:
				firstAddWeeks = 0;
				lastAddWeeks  = 0;
		};
		//recalc first and last days in table
		var Gfd=gtime(firstdayDate);
		var Gld=gtime(lastdayDate); 
		firstshowdayDate = new Date(from8(move8(Gfd.to8,1-Gfd.week-7 * firstAddWeeks - (1-setcache['weekstartson']))));
		lastshowdayDate = new Date(from8(move8(Gld.to8,7-Gld.week+7 * lastAddWeeks - (1-setcache['weekstartson']))));

		//recalc numers of weeks in table
		this.weeksnum = this.GetWeeksNum(firstshowdayDate, lastshowdayDate);
		this_date = new Date(firstshowdayDate);

		for(w = 1; w <= this.weeksnum; w++){
			var cur_week = $("sc_week_"+w);
			cur_day = cur_week.getElementsByTagName("td");
			for(k = 1; k <=7; k++){
				TD = cur_day[k-1];

				td8=to8(this_date);
				if(this_date.getMonth() == todayDate.getMonth() && this_date.getFullYear() == todayDate.getFullYear() && this_date.getDate() == todayDate.getDate()){
					TD.className = 'today';
				} else if (view == DAY && (td8 == showLimits.day)) {
					TD.className = 'select';
				} else if (view==WEEK && (td8 >= showLimits.weekFrom && td8 <= showLimits.weekTill )) {
					TD.className = 'select';
				} else if (view==MONTH && (td8 >= miniLimits.monthFrom && td8 <= miniLimits.monthTill)) {
					TD.className = 'select';
				} else if (setcache['showweekends'] == 1){
					if ((k==6 || k==7) && setcache['weekstartson'] == 1) TD.className = 'weekend';
					else if ((k==1 || k==7) && setcache['weekstartson'] == 0) TD.className = 'weekend';
					else TD.className = 'basic';
				} else {
					TD.className = 'basic';
				};
				
				var link_class = 'CalLink';
				if (this_date.getMonth() != month) {
					if(setcache['showweekends'] == 1) link_class = (k==6 || k==7)? 'CalLinkInactiveWeekend':'CalLinkInactive';
					else if (setcache['showweekends'] == 0) link_class = (k==1 || k==7)? 'CalLinkInactiveWeekend':'CalLinkInactive';
				};
				var day_const = fnum(this_date.getFullYear(),4)+fnum((this_date.getMonth()+1),2)+fnum(this_date.getDate(),2);
				CleanNode(TD);
				var a = CreateChild(TD, 'a');
				a.id = day_const;
				a.className = link_class;
				a.href = 'javascript:void(1);';
				var obj = this;
				var this_month = this_date.getMonth();
				/*if ((view == DAY && (td8 != showLimits.day)) || 
					(view == WEEK && !(td8 >= showLimits.weekFrom && td8 <= showLimits.weekTill)) || 
					(view == MONTH && this_month!= month)
				)
				{*/
					a.onclick = function() { switch2date(this.id); }
				//}

				a.innerHTML = this_date.getDate();

				var evex=(all_events_dates[day_const] != undefined); 

				a.style.fontWeight=(evex?"bold":"normal");
				a.style.fontStyle="normal";

				this_date.setDate(this_date.getDate() + 1);
			}
		}
	}

};//CCalendarTable.prototype

/********************/

function CCalendarTableEvent (parent_id)
{
	this.WeekDaysNames = [
		Lang.CalendarTableDayMonday,
		Lang.CalendarTableDayTuesday,
		Lang.CalendarTableDayWednesday,
		Lang.CalendarTableDayThursday,
		Lang.CalendarTableDayFriday,
		Lang.CalendarTableDaySaturday,
		Lang.CalendarTableDaySunday
	];
	this.m_names = [
		Lang.FullMonthJanuary,
		Lang.FullMonthFebruary,
		Lang.FullMonthMarch,
		Lang.FullMonthApril,
		Lang.FullMonthMay,
		Lang.FullMonthJune,
		Lang.FullMonthJuly,
		Lang.FullMonthAugust,
		Lang.FullMonthSeptember,
		Lang.FullMonthOctober,
		Lang.FullMonthNovember,
		Lang.FullMonthDecember
	];
	this.dms = 86400000; // 86400000 milliseconds in one day
	this.weeksnum = 7;

	this.SelectedDate		= null;
	this.HtmlContainer		= null;
	this.prevMonthSwitcher	= null;
	this.nextMonthSwitcher	= null;
	this.currentMonth		= null;
	this.weekday_Table		= null;
	this.parent_id			= parent_id;
	this.inp				= null;

	this.Create();
	this.SetDateFromPicker = function (day,month,year) { this.Hide(); }

}


CCalendarTableEvent.prototype = {
	//Show Calendar after onClick on img
	Create: function ()
	{
		this.HtmlContainer = $(this.parent_id);
		this.HtmlContainer.className = 'wm_hide';

		// create TABLE
		var m = CreateChild(this.HtmlContainer, 'table');
		m.className = 'Calendar_Title';
		m.style.margin = '0px';
		m.style.borderColor = '#696969';
		m.style.color = '#696969';
		var m_tr_2 = m.insertRow(0);
		var m_td_21 = m_tr_2.insertCell(0);
		var m_td_22 = m_tr_2.insertCell(1);
		var m_td_23 = m_tr_2.insertCell(2);

		m_td_21.style.width = '32px';
		m_td_21.style.textAlign = 'right';

		m_td_23.style.width = '32px';
		m_td_23.style.textAlign = 'left';

		m_td_22.style.textAlign = 'center';
		m_td_22.style.width = '40%';

		// Month Row
		var obj = this;
		var img = CreateChild(m_td_21, 'img');
		img.id = this.parent_id + "_prevMonth";
		img.alt = Lang.AltPrevMonth;
		img.title = Lang.AltPrevMonth;
		img.style.border = '0';
		img.src = './calendar/skins/calendar/minicalendar_arrow_left_activ.gif';
		img.style.width = "11px";
		img.style.height = "11px";
		img.style.cursor = "pointer";
		this.prevMonthSwitcher = img;

		// td_middle_place
		this.currentMonth = m_td_22;

		img = CreateChild(m_td_23, 'img');
		img.id = this.parent_id + "_nextMonth";
		img.alt = Lang.AltNextMonth;
		img.title = Lang.AltNextMonth;
		img.style.border = '0';
		img.src = './calendar/skins/calendar/minicalendar_arrow_right_activ.gif';
		img.style.width = "11px";
		img.style.height = "11px";
		img.style.cursor = "pointer";
		this.nextMonthSwitcher = img;
		this.inp = CreateChildWithAttrs(this.HtmlContainer, 'input', [['type', 'hidden'], ['name', this.parent_id+"_currentMonth"], ['id', this.parent_id+"_currentMonth"]]);


		this.weekday_Table = CreateChild(this.HtmlContainer, 'table');
		this.weekday_Table.cellPadding = '0';
		this.weekday_Table.cellSpacing = '0';
		this.weekday_Table.valign = 'middle';
		this.weekday_Table.className = 'calendar_block';
		this.weekday_Table.style.borderColor = '#696969';

		var TR = this.weekday_Table.insertRow(0);
		for(wd = 0; wd < 7; wd++)
		{
			var TD = TR.insertCell(wd);
			TD.className = 'title';
		};

		for(w = 1; w <= this.weeksnum; w++){
			var TR = this.weekday_Table.insertRow(w);
			for(k = 1; k<=7; k++){
				var TD = TR.insertCell(-1);
				TD.valign = 'middle';
			}
		};

		this.RefreshCalendarSelector(0,0,0);
	},


	Show: function ()
	{
		this.HtmlContainer.className = 'box';
		this.HtmlContainer.style.position = 'absolute';
		this.HtmlContainer.style.zIndex = '2001';
	},
	
	Hide: function ()
	{
		this.HtmlContainer.className = 'wm_hide';
	},

	//Return days in month
	GetDaysInMonth: function (month,year)
	{
		month = ( month<1 ) ? 0 : (( month>12 ) ? 11 : month - 1);
		var arDaysInMonth_Usual = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		var arDaysInMonth_Leap 	= [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		if ( (year % 4) == 0 && (year % 100) != 0 || (year % 400) == 0 ) 
			return arDaysInMonth_Leap[month];
		else
			return arDaysInMonth_Usual[month];
	},
	
	// Return day in week: 0 - Mo, 1 - Tu ...
	GetDay: function ( cDate )
	{
		var wDay = cDate.getDay() - 1;
		if ( wDay == -1 ) wDay = 6;
		return wDay;
	},

	GetWeeksNum: function (firstshowdayDate, lastshowdayDate)
	{
		var weeksnum = Math.ceil(((lastshowdayDate - firstshowdayDate) / this.dms) / 7);
		return weeksnum;
	},


	RefreshCalendarSelector: function(day,month,year) //fill calendar with new data
	{
		var todayDate = new Date();
		var obj = this;

		// checking input data
		if( month == 0 || day == 0 || year == 0 )
		{
			month = todayDate.getMonth()+1;
			day = todayDate.getDate();
			year = todayDate.getFullYear();
		};
		// For Previous Month
		var PM_prev_month = month -1;
		var PM_prev_year = year;
		if (PM_prev_month == 0)
		{
			PM_prev_month = 12;
			PM_prev_year = year -1;
		};
		// For Next Month
		var NM_next_month = Number(month) +1;
		var NM_next_year = year;

		if (NM_next_month == 13)
		{
			NM_next_month = 1;
			NM_next_year = Number(year) + 1;
		};

		//Define drop down select
		this.prevMonthSwitcher.onclick = CreateChangeMonthFunc(obj, PM_prev_month, PM_prev_year);
		this.nextMonthSwitcher.onclick = CreateChangeMonthFunc(obj, NM_next_month, NM_next_year);

		this.currentMonth.innerHTML = this.m_names[month - 1] + '&nbsp;' + year;
		this.inp.value = month+'_'+year;

		//Define days in calendar table
		var days_in_month = this.GetDaysInMonth(month,year);
		month = month - 1;

		var mDate = new Date(year,month,day);

		var firstdayDate = new Date(mDate.getFullYear(),mDate.getMonth(),1); // first day of month
		var lastdayDate = new Date(mDate.getFullYear(),mDate.getMonth(),days_in_month);	// last day of month

		var firstshowdayDate = firstdayDate.setTime(firstdayDate.getTime() - this.dms * this.GetDay(firstdayDate)); //in millisecconds
		var lastshowdayDate  = lastdayDate.setTime(lastdayDate.getTime() + (this.dms * ( 6 - this.GetDay(lastdayDate) ))); //in milliseconds

		this.weeksnum = this.GetWeeksNum(firstshowdayDate, lastshowdayDate);
		var firstAddWeeks;
		var lastAddWeeks;
		switch (this.weeksnum)
		{
			case 4:
				firstAddWeeks = 1;
				lastAddWeeks  = 2;
				break;
			case 5:
				firstAddWeeks = 1;
				lastAddWeeks  = 1;
				break;
			case 6:
				firstAddWeeks = 0;
				lastAddWeeks  = 1;
				break;
			default:
				firstAddWeeks = 0;
				lastAddWeeks  = 0;
		};
		//recalc first and last days in table
		var Gfd=gtime(firstdayDate);
		var Gld=gtime(lastdayDate); 
		firstshowdayDate = new Date(from8(move8(Gfd.to8,1-Gfd.week-7 * firstAddWeeks - (1-setcache['weekstartson']))));
		lastshowdayDate = new Date(from8(move8(Gld.to8,7-Gld.week+7 * lastAddWeeks - (1-setcache['weekstartson']))));

		//recalc numers of weeks in table
		this.weeksnum = this.GetWeeksNum(firstshowdayDate, lastshowdayDate);
		firstdayDate = (mDate.getTime()-((mDate.getDate()-1)*this.dms)); // first day of month
		lastdayDate = (mDate.getTime()+((days_in_month-mDate.getDate())*this.dms));	// last day of month

		this_date = new Date(firstshowdayDate);

		var cur_week = this.weekday_Table.getElementsByTagName("tr");
		for(w = 0; w <= this.weeksnum; w++){
			if (w==0) {
				tdHeaders = cur_week[w].getElementsByTagName("td");
				for(i = 0; i<tdHeaders.length; i++)
				{
					if (setcache['weekstartson'] == 0) {
						tdHeaders[i].innerHTML = (i==0)?this.WeekDaysNames[6]:this.WeekDaysNames[i-1];
					} else {
						tdHeaders[i].innerHTML = this.WeekDaysNames[i]; // 'Mo','Tu','We','Th','Fr','Sa','Su'
					}
				}
			} else {
				cur_day = cur_week[w].getElementsByTagName("td");
				for(k = 1; k <=7; k++){
					TD = cur_day[k-1];

					td8=to8(this_date);
					if(this_date.getMonth() == todayDate.getMonth() && this_date.getFullYear() == todayDate.getFullYear() && this_date.getDate() == todayDate.getDate()){
						TD.className = 'today';
					} else {
						TD.className = 'basic';
					};

					var link_class = 'CalLink';
					if (this_date.getMonth() != month) {
						if(setcache['showweekends'] == 1) link_class = (k==6 || k==7)? 'CalLinkInactiveWeekend':'CalLinkInactive';
						else if (setcache['showweekends'] == 0) link_class = (k==1 || k==7)? 'CalLinkInactiveWeekend':'CalLinkInactive';
					};
					var day_const = fnum(this_date.getFullYear(),4)+fnum((this_date.getMonth()+1),2)+fnum(this_date.getDate(),2);
					CleanNode(TD);
					var a = CreateChild(TD, 'a');
					a.id = this.parent_id+"_"+day_const;
					a.className = link_class;
					a.href = 'javascript:void(1);';
					var obj = this;
					a.onclick = function() {
						EventCreatePickerFunc(obj, this.id.slice((this.id.indexOf("_")+1),this.id.length));
					};
					a.innerHTML = this_date.getDate();

					this_date.setDate(this_date.getDate() + 1);
				}//end for
			}
		}
	}
};//CCalendarTableEvent.prototype

function EventCreatePickerFunc(obj, dt){
	date = new Date(dt.substr(0,4), (Number(dt.substr(4,2))-1), dt.substr(6,2));
	obj.onpickdate(date);
	obj.SetDateFromPicker(date.getDate(), date.getMonth(), date.getFullYear());
}
/*
function CreatePickerFunc(obj, this_date) {
	return function () {
		obj.SetDateFromPicker(this_date.getDate(), this_date.getMonth(), this_date.getFullYear());
		switch2date(this_date); 
	}
}*/

function CreateChangeMonthFunc(obj, PM_prev_month, PM_prev_year) {
	return function () {
		obj.RefreshCalendarSelector(1, PM_prev_month, PM_prev_year);
	}
}

function CreateCalendar() {
	var calendarParent = $('mini_calendar_box');
	var till = $('EventDateTill');
	var from = $('EventDateFrom');
	var input_timeFrom = $('EventTimeFrom');
	var input_timeTill = $('EventTimeTill');


	calendarTableStart = new CCalendarTableEvent("st");
	calendarTableStart.onpickdate = function(date)
	{
		from.value = ConvertFromDateToStr(date);
		till.value = from.value;
		CreateTimeTill(input_timeTill.value, input_timeFrom.value);
	};

	calendarTableEnd = new CCalendarTableEvent("en");
	calendarTableEnd.onpickdate = function(date)
	{
		var date_from = ConvertFromStrToDate(from.value);
		if(date <= date_from){
			till.value = from.value;
			CreateTimeTill(input_timeTill.value, input_timeFrom.value);
		}else{
			till.value = ConvertFromDateToStr(date);
			CreateTimeTill(input_timeTill.value);
		}
	};
	till.onfocus = function() {
		calendarTableStart.Hide();
		calendarTableEnd.Show();
		if (timeSelectorTill != null) {
			timeSelectorTill.Hide();
		};
		if (timeSelectorFrom != null) {
			timeSelectorFrom.Hide();
		}
	};
	from.onfocus = function() {
		calendarTableStart.Show();
		calendarTableEnd.Hide();
		if (timeSelectorTill != null) {
			timeSelectorTill.Hide();
		};
		if (timeSelectorFrom != null) {
			timeSelectorFrom.Hide();
		}
	};

	calendarInManager = new CCalendarTable(calendarParent);
	calendarInManager.Hide();
	calendarInManager.Show();
}


function CSharingForm() {
	this.share_window				= $('share_window');
	this.publicateCalendar			= $('publicateCalendar'); //bool
	this.publicationLevelContainer	= $('publicationLevelContainer');
	this.publicationLevel			= $('publicationLevel');
	this.publicationUrl				= $('publicationUrl');
	this.sharedEmail				= $('sharedEmail');
	this.publicationHash			= $('publicationHash');
	this.sharedPermission			= $('sharedPermission');
	this.addShare					= $('addShare');
	this.shareParent				= $('shareParent');
	this.share_save					= $('share_save');
	this.share_cancel				= $('share_cancel');
	//this.loader						= $('loader');

	this.shareform_id				= $('shareform_id');
	this.shares = new Array();
	this.shares_del = new Array();

	this.initialize();
}
CSharingForm.prototype = {
	initialize: function() {
		var obj = this;
		this.publicateCalendar.onclick = function() {
			obj.expandPublicationLevel();
		};
		this.publicationUrl.onclick = function() {
			this.select();
		};
		this.sharedEmail.onfocus = function() {
			if(this.value == Lang.SharedTitleEmail) {
				this.value = '';
				this.style.color = '#696969';
			}
		};
		this.sharedEmail.onblur = function() {
			if(this.value == '') {
				this.style.color = '#aaa';
				this.value = Lang.SharedTitleEmail;
			}
		};
		this.addShare.onclick = function() {
			obj.AddShare(0, obj.sharedEmail.value, obj.sharedPermission.value, 'add');
		};
		this.share_save.onclick = function() {
			obj.SaveShare();
		};
		this.share_cancel.onclick = function() {
			obj.CancelShare();
		};
	},
	/*getHash : function() {
		var arr = new Array(
					 'a','b','c','d','e','f','g','h','i',
					 'j','k','l','m','n','o','p','q','r',
					 's','t','u','v','w','x','y','z',  
					 'A','B','C','D','E','F','G','H','I',
					 'J','K','L','M','N','O','P','Q','R',
					 'S','T','U','V','W','X','Y','Z', 
					 '1','2','3','4','5','6','7','8','9','0', '-', '_');
		var hash = "";
		var pattern = /^((?=[^a-z]*[a-z])(?=[^A-Z]*[A-Z])(?=[^0-9-_]*[0-9-_]).{6,})$/;
		var number = 8; //password length
		var index = 0;
		for(var i = 0; i < number; i++)  
		{  
			index = Math.round(Math.random()*(arr.length - 1));
			hash += arr[index];
		};
		if (!pattern.test(hash)) {
			this.getHash();
		};
		return hash;
	},*/
	expandPublicationLevel:function() {
		if (this.publicateCalendar.checked) {
			if (typeof(this.shareform_id.value) != "undefined") {
				var calendar_data = mycache_c.calendars[this.shareform_id.value];
				if (calendar_data['publication_level'] != null && calendar_data['publication_hash'] != null) {
					this.publicationHash.value = calendar_data['publication_hash'];
					this.publicationUrl.value = getMainURL()+publication_url+"?calendar="+calendar_data['publication_hash'];
					this.publicationLevel.options[calendar_data['publication_level'] - 1].selected = true;
				} else {
					//this.loader.style.display = "block";
					this.share_save.disabled = true;
					var url = processing_url+'?action=get_publication';
					var req = getXMLHTTPRequest();
					var res = '';
					var hash_arr = new Array();
					if (req) {
						try {
							req.open("GET",url,false);
							req.send(null);
							res = req.responseText;
						} catch(e) {  };

						var result = res.parseJSON();
						if (!servErr(result,Lang.ErrorGetPublicationHash)) { 
							for (var i in result)
							{
								if (typeof(result[i]) == 'function') continue;
								hash_arr[i] = result[i];
							};
						}
					}

					this.publicationHash.value = hash_arr['hash'];
					this.publicationUrl.value = getMainURL()+publication_url+"?calendar="+hash_arr['hash'];
					this.publicationLevel.options[0].selected = true;

					//this.loader.style.display = "none";
					this.share_save.disabled = false;
				};
				this.publicationLevelContainer.style.display = "block";
			}
			
		} else {
			this.publicationLevelContainer.style.display = "none";
		}
	},
	ShowForm: function(id_calendar) {
		this.calendar_id = id_calendar;
		this.shares.length = 0;
		this.shares_del.length = 0;
		var calendar_data = mycache_c.calendars[id_calendar];

		this.shareform_id.value = id_calendar;
		removeQuickMenu();
		var color_number = calendar_data['calendar_color'];
		$('sharecontainer').className = 'eventcontainer_'+color_number;

		if (calendar_data['publication_level'] != null) {
			this.publicateCalendar.checked = true;
			this.publicationLevel.options[calendar_data['publication_level'] - 1].selected = true;
			this.publicationUrl.value = getMainURL()+publication_url+"?calendar="+calendar_data['publication_hash'];
			this.publicationLevelContainer.style.display = "block";
			this.publicationHash.value = calendar_data['publication_hash'];
		} else {
			this.publicateCalendar.checked = false;
			this.publicationUrl.value = "";
			this.publicationLevelContainer.style.display = "none";
			this.publicationHash.value = "";
		};
		CleanNode(this.shareParent);
		if (typeof(calendar_data['shares']) != "undefined" && calendar_data['shares'].length > 0) { 
		for (var i in calendar_data['shares']) {0
				//this.AddShare(calendar_data['shares'][i]['id_share'], calendar_data['shares'][i]['id_to_user'], calendar_data['shares'][i]['email_to_user'], calendar_data['shares'][i]['int_access_level'], 'show');
				this.AddShare(calendar_data['shares'][i]['id_share'], calendar_data['shares'][i]['email_to_user'], calendar_data['shares'][i]['int_access_level'], 'show');
			}
		};

		this.sharedEmail.value = Lang.SharedTitleEmail;
		this.sharedEmail.style.color = "#aaa";
		setMaskHeight();
		this.share_window.style.display='block';
		if(SafariDetect().isSafari) { 
			$('share_form').style.top = window.innerHeight / 2 + 'px';
		};
	},
	//AddShare: function(id_share, id_user, email, permission, action) {
	AddShare: function(id_share, email, permission, action) {
		action = Trim(action);
		if (action != "add" && action != "show") {
			return;
		};

		var emailValue = Trim(this.sharedEmail.value);
		var validate = new CValidate();

		if (action == "add") {
			if (emailValue == "" || emailValue == Lang.SharedTitleEmail) {
				alert(Lang.WarningEmailFieldFilling);
				this.sharedEmail.focus();
				return;
			};
			if (!validate.IsCorrectEmail(emailValue)) {
				alert(Lang.WarningCorrectEmail);
				this.sharedEmail.value = "";
				this.sharedEmail.focus();
				return;
			};
		};

		var permissionsValues = [
			{id:0, name:Lang.SharePermission1},
			{id:1, name:Lang.SharePermission2},
			{id:2, name:Lang.SharePermission3},
			{id:3, name:Lang.SharePermission4}
		];

		var errorText = "";
		var error_code = 0;
		if (action == "add") {
			var url = processing_url+'?action=check_share&email='+encodeURIComponent(emailValue)+"&calendar_id="+this.shareform_id.value;
			var req = getXMLHTTPRequest();
			var res = '';

			if (req) {
				try {
					req.open("GET",url,false);
					req.send(null);
					res = req.responseText;
				} catch(e) {  };
				var share_arr = new Array();
				var result = res.parseJSON();
				if (!servErr(result,Lang.ErrorGetShare)) { 
					share_arr = result;
				};
				
				if (typeof(share_arr['shares_errors']) != "undefined") {
					if (share_arr['shares_errors'].length>0) {
						for (var i=0; i<share_arr['shares_errors'].length; i++) {
							error_code = share_arr['shares_errors'][i]['error_code'];
							var replace_str = "";
							if (error_code == 1) { //user doesnt exist
								replace_str = Lang.ErrorUpdateSharing1;
							};
							if (error_code == 2) { //user is me or user is multiuser or calendar belong to user, who shared calendar to us
								replace_str = Lang.ErrorUpdateSharing2;
							};
							if (error_code == 3) { //already shared to this user
								replace_str = Lang.ErrorUpdateSharing3;
							};
							errorText += replace_str.replace('%s', emailValue)+"\n";
						};
						if (errorText != "") {
							alert(errorText);
						}
					}
				}
			}
		};

		if (error_code == 0) {
			var share = document.createElement('div');
			share.className = "share";

			var col1 = document.createElement('div');
			col1.className = "col1";
			var txtemail = document.createTextNode(email);
			col1.appendChild(txtemail);
			share.appendChild(col1);

			var col2 = document.createElement('div');
			col2.className = "col2";
			var select = document.createElement('select');

			for (var i=0; i<permissionsValues.length; i++) {
				var option = document.createElement('option');
				option.value = permissionsValues[i].id;
				option.innerHTML = permissionsValues[i].name;
				if (i == permission) option.selected = true;
				select.appendChild(option);
			};
			var obj = this;
			select.onchange = function () {
				obj.shares.push({id:delbtn.id, user:email, level:select.value});
			};
			select.className = "input";
			col2.appendChild(select);
			share.appendChild(col2);

			var col3 = document.createElement('div');
			col3.className = "col3";

			var delbtn = document.createElement('img');
			delbtn.src = "./calendar/skins/calendar/delete.png";
			delbtn.id = id_share;
			delbtn.className = "imgbtn";
			delbtn.alt = Lang.TitleDelete;
			delbtn.title = Lang.TitleDelete;
			var obj = this;
			delbtn.onclick = function() {
				if (confirm(Lang.ConfirmAreYouSure)) {
					share.style.display = "none";
					if (this.id != 0) {
						obj.shares_del.push(this.id);
					}
				}
			};

			col3.appendChild(delbtn);
			share.appendChild(col3);

			var cleardiv = document.createElement('div');
			cleardiv.className = "clear";
			share.appendChild(cleardiv);

			this.shareParent.appendChild(share);
			if (id_share == 0) this.shares.push({id:id_share, user:email, level:permission});
			this.sharedEmail.value = Lang.SharedTitleEmail;
			this.sharedEmail.style.color = "#aaa";
		} else {
			this.sharedEmail.select();
		};
	},

	CancelShare: function() {
		this.share_window.style.display='none';
	},

	SaveShare: function() {
		var obj = this;
		var url = processing_url;
		var calendar_id = this.shareform_id.value;
		var params = 'action=update_share&calendar_id=' + calendar_id + '&nocache=' + Math.random();
		
		var calendar_data = mycache_c.calendars[calendar_id];
		var publicationLevel_value = null;
		if (this.publicateCalendar.checked) {
			publicationLevel_value = this.publicationLevel.value;
			params += '&publication_hash='+ this.publicationHash.value;
		} else {
			publicationLevel_value = 0;
		};
		
		if (publicationLevel_value != null) params += '&publication_level='+publicationLevel_value;
		if (this.shares.length>0) {
			for (var i=0; i<this.shares.length; i++) {
				params += "&share_ids[" + i + "]="+this.shares[i].id+"&share_emails[" + i + "]=" + this.shares[i].user + "&share_levels[" + i + "]=" + this.shares[i].level;
			}
		};
		if (typeof (this.shares_del) != "undefined" && this.shares_del.length > 0) {
			for (var i=0; i<this.shares_del.length; i++) {
				params += "&share_delete["+i+"]="+this.shares_del[i];
			}
		};
		var req = getXMLHTTPRequest();
		var res = '';
		if (req) {
			try {
				req.open("POST",url,false);
				req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
				req.setRequestHeader("Content-length", params.length);
				req.setRequestHeader("Connection", "close");
				req.send(params);
				res = req.responseText;
			} catch(e) {  };

			var calendar_arr = res.parseJSON();
			if (!servErr(calendar_arr,Lang.ErrorUpdateSharing)) { 
				var calendar_id = calendar_arr['calendar_id'];

				if (typeof calendar_id != "undefined" && typeof(mycache_c.calendars[calendar_id]) != "undefined") {
					mycache_c.calendars[calendar_id]['publication_hash'] = (typeof(calendar_arr['publication_hash']) != "undefined")?calendar_arr['publication_hash']: null;
					if (typeof(calendar_arr['publication_level']) != "undefined") {
						mycache_c.calendars[calendar_id]['publication_level'] =  calendar_arr['publication_level'];
						$('calendar_'+calendar_id+'public').className = "ml_publiclink";
					} else {
						mycache_c.calendars[calendar_id]['publication_level'] = null;
						$('calendar_'+calendar_id+'public').className = "hide";
					};

					if (typeof(calendar_arr['shares'] != "undefined")) {
						mycache_c.calendars[calendar_id]['shares'] = calendar_arr['shares'];
					};
					if (typeof(calendar_arr['shares_errors']) != "undefined") {
						if (calendar_arr['shares_errors'].length>0) {
							var errorText = "";
							var error_code = 0;
							for (var i=0; i<calendar_arr['shares_errors'].length; i++) {
								error_code = calendar_arr['shares_errors'][i]['error_code'];
								var replace_str = "";
								if (error_code == 1) {
									replace_str = Lang.ErrorUpdateSharing1;
								};
								if (error_code == 2) {
									replace_str = Lang.ErrorUpdateSharing2;
								};
								if (error_code == 3) {
									replace_str = Lang.ErrorUpdateSharing3;
								};
								errorText += replace_str.replace('%s', calendar_arr['shares_errors'][i]['email_to_user'])+"\n";
							};
							if (errorText != "") {
								alert(errorText);
							}
						}
					}
				}
			}
		};
		this.share_window.style.display='none';
		HideInfo();
	}
}

function CEventForm() {

	this.event_window			= $('edit_window');
	this.event_form				= $('edit_form');
	this.evform_id				= $('evform_id');
	this.calendar_id			= $('id_calendar');
	this.eventcontainer			= $('eventcontainer');
	this.toolbar_new_event		= $('toolbar_new_event');
	this.window_header			= $('ef_fulldate');
	this.EventSubject			= $('EventSubject');
	this.edit_select_box		= $('edit_select_box');
	this.color_calendar_now		= $('color_calendar_now');
	this.calen_sal				= $('calen_sal');
	this.calendar_arrow			= $('calendar_arrow');
	this.edit_select_box_list	= $('edit_select_box_list');
	this.EventTimeFrom			= $('EventTimeFrom');
	this.EventDateFrom			= $('EventDateFrom');
	this.EventTimeTill			= $('EventTimeTill');
	this.EventDateTill			= $('EventDateTill');
	this.EventDescription		= $('EventDescription');

	this.closebut	= $('closebut');
	this.savebut	= $('button_save');
	this.cancelbut	= $('cancelbut');
	this.delbut		= $('delbut');

	this.initialize();
}

CEventForm.prototype = {
	initialize: function() {
		var obj = this;

		this.toolbar_new_event.onclick = function() {
			if (mycache_c.calendars != undefined) {
				$('calendarColorNumber').value = 0;
				obj.CreateEventForm();
			}
		},
		this.EventDescription.onfocus = function() {
			calendarTableStart.Hide();
			calendarTableEnd.Hide();
		};
		this.closebut.onclick = function() {
			obj.CancelEventForm();
		};
		this.savebut.onclick = function() {
			obj.SubmitEventForm();
		};
		this.cancelbut.onclick = function() {
			obj.CancelEventForm();
		};
		this.delbut.onclick = function() {
			obj.DeleteEventForm();
		};

	},

	getClockTime : function() {
		var hours, hours_till, minutes_till;
		var result = new Array();
		var time = new Date();
		var time_till = new Date();
		var minutes = time.getMinutes();

		time_till.setHours(time_till.getHours() + 1);

		if (minutes > 30) {
			minutes = ':00';
			time.setHours(time.getHours() + 1);
		 	minutes_till = ':30';
		} else {
			minutes = ':30';
			minutes_till = ':00';
		};
		hours = time.getHours();
		hours_till = time_till.getHours();
		hours_till = (hours_till==0 && hours!=0)?24:hours_till;

		result[0] = fnum(hours,2) + minutes;
		result[1] = fnum(hours_till,2) + minutes_till;

		if (setcache['timeformat'] == 1) {
			for (var i=0; i<timeFormat2.length; i++) {
				if (result[0] == timeFormat2[i].Value) {
					result[0] = timeFormat1[i].Value;
				}
				if (result[1] == timeFormat2[i].Value) {
					if (i==0) continue;
					result[1] = timeFormat1[i].Value; 
				}
			}
		};
		return result;
	},

	CreateEventForm : function(idc) {
		idc = (idc == null) ? 0 : idc;
		var date = mydate;
		var time = this.getClockTime();
		CreateTimeTill(time[1],time[0]);
		CreateTimeFrom(time[0]);
		tfrom = time[0]; 
		ttill = time[1];  

		if (tfrom == "00:00" || tfrom == "12 AM") {
			var curDate = new Date();
			if (curDate.getHours() == 23 && curDate.getMinutes()>30) {
				date = new Date(date.getFullYear(), date.getMonth(), date.getDate()+1);
			}
		};

		var editevent_form_data = {
			subject 	: '',
			timeFrom	: tfrom,
			timeTill	: ttill,
			fullFromDate: date,
			fullTillDate: date,
			description	: '',
			event_id	: 0, //0  if new event
			calendar_id : idc
		};
		this.ShowEventForm(editevent_form_data);
	},

	CancelEventForm : function() {
		this.event_window.style.display='none'; 
		var divCheckPanel = $("divCheckPanel");
		if (divCheckPanel != undefined) divCheckPanel.style.display = "none";
		this.ClearEventForm();
	},
	ClearEventForm : function() {
		calendarTableStart.Hide();
		calendarTableEnd.Hide();
		timeSelectorTill.Remove();
		timeSelectorFrom.Remove();
		this.event_form.style.display = 'none';
	},
	ShowHideCalendarsList : function(){
		var selList = this.edit_select_box_list;
		if(typeof(selList.opened) == "undefined") selList.opened = false;
		if (selList.opened == false || selList.style.display=='none')
		{
			selList.style.display = 'block';
			selList.style.visibility = 'visible';
			selList.opened = true;
			var len=0;
			selList.style.width = "auto";
			var divs = selList.getElementsByTagName("div");
			if(FireFoxDetect())
			{
				selList.style.width = (selList.clientWidth>=109)?('auto'):("104px");
			}else{
				selList.style.width = (selList.clientWidth>=109)?((selList.clientWidth > 290) ? ((selList.clientWidth +15) + 'px') : 'auto'):("104px");
			};
		} else {
			selList.style.display = 'none';
			selList.style.visibility = 'hidden';
			selList.opened = false;
		}
	},

	SubmitEventForm : function() {
/*--check data --*/
		if (this.calen_sal.value == '') {
			alert(Lang.ErrorCalendarNotCreated);
			return;
		};

		this.EventSubject.value		= Trim(this.EventSubject.value);
		this.EventDescription.value	= Trim(this.EventDescription.value);
		if(this.EventSubject.value == ''){
			alert(Lang.WarningSubjectBlank);
			this.EventSubject.focus();
			return;
		};
		var strTimeFrom = this.EventTimeFrom.value;
		var strTimeTill = this.EventTimeTill.value;
		var strDateFrom = this.EventDateFrom.value;
		var strDateTill = this.EventDateTill.value;

		var time_from = CheckTimeStr(strTimeFrom);
		var time_till = CheckTimeStr(strTimeTill);
		if (time_from == null || time_till == null) {
			alert(Lang.WarningIncorrectTime);
			return;
		} else {
			if (time_from.timeInterval == null) {//timeformat = 1
				if (time_from.hours>24 || (time_from.minutes!="30" &&  time_from.minutes!="00"))	{
					alert(Lang.WarningIncorrectFromTime);
					return;
				}
			} else {//timeformat = 2
				if (time_from.hours>12 || (time_from.minutes!="30" && time_from.minutes!=null)) {
					alert(Lang.WarningIncorrectFromTime);
					return;
				}
			};
			if (time_till.timeInterval == null) {//timeformat = 1
				if (time_till.hours>24 || (time_till.minutes!="30" &&  time_till.minutes!="00")) {
					alert(Lang.WarningIncorrectTillTime);
					return;
				}
			} else {//timeformat = 2
				if (time_till.hours>12 || (time_till.minutes!="30" && time_till.minutes!=null)) {
					alert(Lang.WarningIncorrectTillTime);
					return;
				}
			}
		};

		var date_from = ConvertFromStrToDate(strDateFrom);
		var date_till = ConvertFromStrToDate(strDateTill);

		if (date_from == null || date_till == null) {
			alert(Lang.WarningIncorrectDate);
			return;
		} else {
			if(date_from.getTime() > date_till.getTime()) {
				alert(Lang.WarningStartEndDate);
				return;
			} else {
				var timeFromId = null, timeTillId = null, timeFromI, timeTillI;

				if (setcache['timeformat'] == 2) {
					var timeOptions = timeFormat2; //defined in _time_selector.js
					var time_f = time_from.hours+":"+time_from.minutes;
					var time_t = time_till.hours+":"+time_till.minutes;
				} else {//setcache['timeformat'] == 1
					var timeOptions = timeFormat1; //defined in _time_selector.js
					var time_f = time_from.hours+((time_from.minutes==null)?'':(':'+time_from.minutes))+" "+time_from.timeInterval;
					var time_t = time_till.hours+((time_till.minutes==null)?'':(':'+time_till.minutes))+" "+time_till.timeInterval;
				};

				//check fromtime field
				for (var i=0; i<timeOptions.length; i++) {
					if (time_f == timeOptions[i].Value) {
						timeFromId = timeOptions[i].Id;
						timeFromI = i;
						break;
					}
				};

				var begin = (setcache['timeformat'] == 1 && (date_from.getTime() == date_till.getTime()))?1:0;
				//check fromtime field
				for (var i=begin; i<timeOptions.length; i++) {
					if (time_t == timeOptions[i].Value) {
						timeTillId = timeOptions[i].Id;
						timeTillI = i;
						break;
					}
				};
				if (((timeFromId == null) || (timeTillId == null) || timeFromId>=timeTillId) && (date_from.getTime() == date_till.getTime())) {
					alert(Lang.WarningStartEndTime);
					return;
				}
			}
		};

		this.event_window.style.display='none';

/*--save data--*/
		ShowInfo(Lang.InfoSaving);
		var subject		= encodeURIComponent(this.EventSubject.value.substr(0,50));
		var description = encodeURIComponent(this.EventDescription.value.substr(0,255));
		var select_calendar = this.calendar_id.value;

		time_from_format = timeFormat2[timeFromI].Value;
		time_till_format = timeFormat2[timeTillI].Value;
		var min = (time_from.minutes != undefined) ? time_from.minutes : 0;
		date_from.setHours(parseToNumber(time_from.hours), min);
		var date_f = to8(date_from);

		date_till = new Date(date_till.getFullYear(), date_till.getMonth(), date_till.getDate());
		min = (time_till.minutes != undefined) ? time_till.minutes : 0;
		date_till.setHours(time_till.hours, min);
		var date_t = to8(date_till);
		if (time_till_format == "24:00") {
			time_till_format = "00:00";
		};

		var days_len = (date_till.getTime() - date_from.getTime()) / 86400000;
		if (days_len > 1) {
			var all_day = 1;
		}else{
			var all_day = 0;
		};

		var id_event = parseInt(this.evform_id.value);
		var divCheckPanel = $("divCheckPanel"); 
		if (divCheckPanel != undefined) divCheckPanel.style.display = "none";

		var req = getXMLHTTPRequest();
		var res = '';
		var url = processing_url+'?action=update_event&event_id=' + id_event + '&name=' + subject + '&text=' + description + '&from=' + date_f + '&till=' + date_t + '&time_from=' + time_from_format + '&time_till=' + time_till_format+'&allday='+all_day+'&nocache=' + Math.random();

		if (id_event == 0) {
			url += '&calendar_id=' + select_calendar;
		} else {
			var event_data = mycache.ids[id_event];
			var old_calendar_id = event_data['calendar_id'];
			if (old_calendar_id != select_calendar) {
				url += '&new_calendar_id='+select_calendar + '&calendar_id=' + old_calendar_id;
			} else {
				url += '&calendar_id=' + select_calendar;
			};
			var old_allday_value = event_data['event_allday'];
		};
		
		if (req) {
			try {
				req.open("GET",url,false);
				req.send(null);
				res = req.responseText;
			} catch(e) { };

			var event = res.parseJSON();

			if (!servErr(event,Lang.ErrorUpdateEvent)) {
				var eid = event['event_id'];

				/*if (mycache.ids[eid] && mycache.ids[eid]['event_name'] != event['event_name']) {
					var ename=event['event_name']; 
					var edate=to8(dt2date(event['event_timefrom']));
					if ((mycache.d[eid]!=undefined)&&(mycache.d[eid])) { mycache.d[eid]['event_name']=ename; set_title(eid,ename,0); }
					if ((mycache.w[eid]!=undefined)&&(mycache.w[eid])) { mycache.w[eid]['event_name']=ename; set_title(eid,ename,1); }
					if ((mycache.m[eid]!=undefined)&&(mycache.m[eid])) { mycache.m[eid]['event_name']=ename; set_title(eid,ename,2); } 
					mycache.ids[eid]['event_name']=ename;
				} else {*/
				
					if (id_event != 0) {
						var date_ff = to8(dt2date(mycache.ids[eid]['event_timefrom']));
						var date_tt = to8(dt2date(mycache.ids[eid]['event_timetill']));
						delevent(event);
						if (event['event_allday'] == 1) {
							if ((date_ff < showLimits.weekTill) && (date_tt > showLimits.weekFrom)) {
								dotrender(mycache.w, date_ff, 1, 7);
							};
							if ((date_ff == showLimits.day) || (date_tt == showLimits.day) || ((date_ff < showLimits.day) && (date_tt > showLimits.day))) {
								dotrender(mycache.d, date_ff, 0, 1);
							};
						} else {
							if ((date_ff>=showLimits.weekFrom)&&(date_ff<=showLimits.weekTill)) {
								dotrender(mycache.w, date_ff, 1, 7);
							};
							if (date_ff==showLimits.day) {
								dotrender(mycache.d, date_ff, 0, 1);
							};
						}
					};
					addevent(event);
					if (event['event_allday'] == 1) {
						if ((date_f < showLimits.weekTill) && (date_t > showLimits.weekFrom)) {
							dotrender(mycache.w, date_f, 1, 7);
						};
						if ((date_f == showLimits.day) || (date_t == showLimits.day) || ((date_f < showLimits.day) && (date_t > showLimits.day))) {
							dotrender(mycache.d, date_f, 0, 1);
						};
					} else {
						if ((date_f>=showLimits.weekFrom) && (date_f<=showLimits.weekTill)) {
							dotrender(mycache.w, date_f, 1, 7);
						};
						if (date_f==showLimits.day) {
							dotrender(mycache.d, date_f, 0, 1);
						};
					};

					ReRenderMonthly();
					calendarInManager.RefreshCalendarSelector(mydate.getDate(), mydate.getMonth()+1, mydate.getFullYear());
				//};
				
				if ((id_event!=0 && old_allday_value == 1) || event['event_allday'] == 1) setWorkAreaOffset();
				RecalcScrollArrows();
			};
		};
		this.ClearEventForm();
		HideInfo();
	},

	DeleteEventForm : function() {
		var confirm_window = $('confirm_window');
		confirm_window.style.display='block';
		if (confirm(Lang.ConfirmAreYouSure)) {
			ShowInfo(Lang.InfoDeleting);
			confirm_window.style.display = 'none';
			this.event_window.style.display = 'none';
			var id_event = parseInt(this.evform_id.value);
			var event_data = mycache.ids[id_event];
			var calendar_id = event_data["calendar_id"];

			if (event_data != undefined) {
				var date_from = to8(dt2date(event_data["event_timefrom"]));
				var date_till = to8(dt2date(event_data["event_timetill"]));

				var req = getXMLHTTPRequest();
				var res = '';
				var url = processing_url+'?action=delete_event&event_id=' + id_event + '&calendar_id=' + calendar_id + '&nocache=' + Math.random();

				if (req)
				{
					try {
						req.open("GET",url,false);
						req.send(null);
						res = req.responseText;
					} catch(e) { };
					var event_arr = res.parseJSON();
					if (!servErr(event_arr,Lang.ErrorDeleteEvent) && (event_arr != undefined)) {
						delevent(event_arr);
						if (event_data['event_allday'] == 1) {
							if ((date_from < showLimits.weekTill) && (date_till > showLimits.weekFrom)) {
								dotrender(mycache.w, date_from, 1, 7);
							};
							if ((date_from == showLimits.day) || (date_till == showLimits.day) || ((date_from < showLimits.day) && (date_till > showLimits.day))) {
								dotrender(mycache.d, date_from, 0, 1);
							};
						} else {
							if (date_from == showLimits.day) dotrender(mycache.d, date_from, 0, 1);
							if ((date_from >= showLimits.weekFrom) && (date_from <= showLimits.weekTill)) dotrender(mycache.w, date_from, 1, 7);
						};
						if (event_data['event_allday'] == 1) setWorkAreaOffset();
						RecalcScrollArrows();
						calendarInManager.RefreshCalendarSelector(mydate.getDate(), mydate.getMonth()+1, mydate.getFullYear());
						ReRenderMonthly();
					}
				};
			};
			this.ClearEventForm();
		} else {
			confirm_window.style.display='none';
			return;
		};
		HideInfo();
		var divCheckPanel = $("divCheckPanel");
		if(divCheckPanel != undefined) divCheckPanel.style.display = "none";
	},

	createCalendarSelect : function() {
		var obj = this;
		if (mycache_c.calendars!=undefined)
		{
			var mas_cal = new Array();
			var my_calendars_cont = document.createElement('div');
			my_calendars_cont.style.paddingBottom="5px";
			this.edit_select_box_list.appendChild(my_calendars_cont);
			var shared_calendars_cont = document.createElement('div');
			shared_calendars_cont.style.borderTop="1px solid #ccc";
			shared_calendars_cont.style.paddingTop="5px";
			shared_calendars_cont.style.display = "none";
			this.edit_select_box_list.appendChild(shared_calendars_cont);

			for (var i in mycache_c.calendars)
			{
				var cl = mycache_c.calendars[i];
				if(typeof(cl) != "undefined")
				{
					var option = document.createElement('div');
					option.id = 'clnd_'+ cl['calendar_id'];
					option.style.position = 'relative';
					var div_color = getNumberOfColor(cl['calendar_color']);

					option.onclick = function()
					{
						var new_calendar = mycache_c.calendars[this.id.substr(5, this.id.length)];
						var form_calendar_id = obj.calendar_id.value;
						obj.calen_sal.innerHTML = HtmlEncode(new_calendar['calendar_name']);
						obj.calen_sal.parentNode.title = HtmlEncode(new_calendar['calendar_name']);
						obj.eventcontainer.className = 'eventcontainer_'+new_calendar['calendar_color'];
						$('clnd_' + form_calendar_id).style.fontWeight = 'normal';
						obj.calendar_id.value = new_calendar['calendar_id'];
						$('clnd_' + new_calendar['calendar_id']).style.fontWeight = 'bold';
						obj.edit_select_box_list.style.display = 'none';
						obj.edit_select_box_list.style.visibility = 'hidden';
						obj.color_calendar_now.style.backgroundColor = getNumberOfColor(new_calendar['calendar_color']);
					};
					if (this.calendar_id.value == cl['calendar_id']) {option.style.fontWeight = 'bold';};
					option.onmouseover = function(){ this.style.backgroundColor = '#DDDDDD'};
					option.onmouseout = function(){ this.style.backgroundColor = '#FFFFFF'};
					option.innerHTML = '<div class="color_pick" style="border: 1px solid #fff; margin:1px 0px 0px 3px; position:relative; background-color: '+div_color+'"></div> '+ '&nbsp;&nbsp;' +  HtmlEncode(cl['calendar_name']);
					mas_cal[i] = option;
					if (cl['sharing_level'] == null) {
						my_calendars_cont.appendChild(option);
					} else if (cl['sharing_level'] == 0 || cl['sharing_level'] == 1) {
						shared_calendars_cont.appendChild(option);
					}
				}
			};
			if (shared_calendars_cont.childNodes.length >0) shared_calendars_cont.style.display = "block";
		}
	},

	removeCalendarSelect : function() {
		if (mycache_c.calendars!=undefined){
			for (var i in mycache_c.calendars)
			{
				if(mycache_c.calendars[i] != undefined){
					var id_cal = mycache_c.calendars[i]['calendar_id'];
					this.edit_select_box_list.style.display = 'none';
					this.edit_select_box_list.style.visibility = 'hidden';
				}
			};
			CleanNode(this.edit_select_box_list);
		}
	},
	/*
	* event_data = {
		subject
		timeFrom
		timeTill
		fullFromDate
		fullTillDate
		description
		event_id
				repeat_period
				repeat_untill
				repeat_times
				repeat_pattern
		};
		calendar_id
	*/
	ShowEventForm : function (event_data) {
		var calendar, color, color_number, calendar_name, calendar_id;
		var obj = this;
		var eventFormIdValue = this.evform_id.value;
		
		this.removeCalendarSelect();
		

		if (event_data.event_id == 0) {
			if (event_data.calendar_id == 0) {
				if (this.evform_id.value == 0 && this.calendar_id.value != 0 && mycache_c.calendars[this.calendar_id.value] != undefined) {
					calendar = mycache_c.calendars[this.calendar_id.value]; 
				} else {
					/* Gets the first calendar from calendar cache and return its */
					if (typeof(mycache_c.calendars)!="undefined")
					{
						for (var i in mycache_c.calendars) 
						{
							if(typeof(mycache_c.calendars[i])!="undefined"){
								calendar = mycache_c.calendars[i];
								break;
							}
						}
					}
				}
			} else {
				calendar = mycache_c.calendars[event_data.calendar_id];
			};
			this.window_header.innerHTML = Lang.EventHeaderNew;
			this.savebut.style.display="inline";
			this.cancelbut.style.display = "inline";
			this.delbut.style.display = "none";
			this.closebut.style.display = "none";
		} else {
			var event_calendar = mycache.ids[event_data.event_id];
			if (typeof(mycache_c.calendars)!="undefined"){
				for (i in mycache_c.calendars)
				{
					if(typeof(mycache_c.calendars[i])!="undefined"){
						if (mycache_c.calendars[i]['calendar_id'] == event_calendar["calendar_id"]) {
							calendar = mycache_c.calendars[i]; 
						}
					}
				}
			};
		};

		if (calendar['sharing_level'] == 2) {
			this.savebut.style.display="none";
			this.cancelbut.style.display = "none";
			this.delbut.style.display = "none";
			this.closebut.style.display = "inline";
			this.window_header.innerHTML = Lang.EventHeaderView;
			this.EventSubject.disabled = true;
			this.EventDescription.disabled = true;
			this.EventTimeFrom.disabled = true;
			this.EventTimeTill.disabled = true;
			this.EventDateFrom.disabled = true;
			this.EventDateTill.disabled = true;
			this.calen_sal.onclick = function() {
				return false;
			};
			this.calen_sal.parentNode.style.cursor = "default";
			this.calendar_arrow.style.display = "none";
			this.calendar_arrow.style.visibility = "hidden";
			this.calendar_arrow.onclick = function() {
				return false;
			};
		} else {
			if (event_data.event_id == 0) {
				this.savebut.style.display="inline";
				this.cancelbut.style.display = "inline";
				this.delbut.style.display = "none";
				this.closebut.style.display = "none";
				this.window_header.innerHTML = Lang.EventHeaderNew;
			} else {
				this.delbut.style.display = "inline";
				this.cancelbut.style.display = "inline";
				this.savebut.style.display="inline";
				this.closebut.style.display = "none";
				this.window_header.innerHTML = Lang.EventHeaderEdit;
			};
			this.EventSubject.disabled = false;
			this.EventDescription.disabled = false;
			this.EventTimeFrom.disabled = false;
			this.EventTimeTill.disabled = false;
			this.EventDateFrom.disabled = false;
			this.EventDateTill.disabled = false;
			this.calen_sal.onclick = function() {
				obj.ShowHideCalendarsList();
			};
			this.calen_sal.parentNode.style.cursor = "pointer";
			this.calendar_arrow.style.display = "block";
			this.calendar_arrow.style.visibility = "visible";
			this.calendar_arrow.onclick = function() {
				obj.ShowHideCalendarsList();
			};
		};

		this.EventSubject.value		= event_data.subject;
		this.EventTimeFrom.value	= event_data.timeFrom;
		this.EventTimeTill.value	= event_data.timeTill;
		this.EventDateFrom.value	= ConvertFromDateToStr(event_data.fullFromDate);
		this.EventDateTill.value	= ConvertFromDateToStr(event_data.fullTillDate);
		this.EventDescription.value	= event_data.description;
		this.evform_id.value		= event_data.event_id;

		color_number	= calendar['calendar_color'];
		color			= getNumberOfColor(calendar['calendar_color']);
		calendar_name	= HtmlEncode(calendar['calendar_name']);
		calendar_id		= calendar['calendar_id'];

		this.eventcontainer.className = 'eventcontainer_'+color_number;
		this.color_calendar_now.style.backgroundColor = color;
		this.calendar_id.value = calendar_id;
		CleanNode(this.calen_sal);
		var calendarNameTxt = document.createTextNode(calendar_name);
		this.calen_sal.appendChild(calendarNameTxt);
		this.calen_sal.parentNode.title = calendar_name;

		setMaskHeight();

		this.event_form.style.display = 'block';
		this.event_window.style.display='block';
		if(SafariDetect().isSafari) { 
			this.event_form.style.top = window.innerHeight / 2 + 'px';
		};
	
		this.createCalendarSelect();
		var tbl_start = $("st_currentMonth").value.split("_");

		if ( (tbl_start[0] != (event_data.fullFromDate.getMonth()+1)) ||  tbl_start[1] !=  event_data.fullFromDate.getFullYear()) {
			calendarTableStart.RefreshCalendarSelector(1, (event_data.fullFromDate.getMonth()+1), event_data.fullFromDate.getFullYear());
		};
		var tbl_end = $("en_currentMonth").value.split("_");
		if ( (tbl_end[0] != (event_data.fullTillDate.getMonth()+1)) ||  tbl_end[1] !=  event_data.fullTillDate.getFullYear()) {
			calendarTableEnd.RefreshCalendarSelector(1, (event_data.fullTillDate.getMonth()+1), event_data.fullTillDate.getFullYear());
		};
		if (calendar['sharing_level'] != 2) this.EventSubject.focus();
	}
}

function CCalendarForm() {

	this.calendar_window			= $('manager_window');
	this.calendar_form				= $('manager_form');
	this.window_header				= $('ef_fulldate_calendar');
	this.calendar_id				= $('clndform_id');
	this.calendar_subject			= $('CalendarSubject');
	this.calendar_description		= $('CalendarDescription');
	this.confirm_window				= $('confirm_window');
	this.calendar_color_number		= $('calendarColorNumber');

	this.savebut	= $('savebut_calendar');
	this.cancelbut	= $("calncelbut_calendar");
	this.delbut		= $('delbut_calendar');

	this.initialize();
}

CCalendarForm.prototype = {
	initialize: function() {
		var obj = this;
		this.calendar_subject.onkeypress = function(e) {
			obj.SaveFormOnEnter(e);
		};
		this.savebut.onclick = function() {
			obj.CalendarFormSave();
		};
		this.cancelbut.onclick = function() {
			obj.CalendarFormCancel();
		};
		this.delbut.onclick = function() {
			obj.CalendarFormDelete();
		};
	},

	SelectColorForNewCalendar : function(numb, color, div)
	{
		div.style.borderColor = '#000';
		for(i = 1; i<13; i++)
		{
			if($('color_'+i).id != div.id)
				$('color_'+i).style.borderColor = '#fff';
		};
		this.calendar_color_number.value = numb;
		$('calendarcontainer').className = 'eventcontainer_'+ numb;
	},

	CalendarFormCreate : function() {
		setMaskHeight();
		this.calendar_window.style.display = 'block';
		if(SafariDetect().isSafari) { 
			this.calendar_form.style.top = window.innerHeight / 2 + 'px';
		};
		this.window_header.innerHTML = Lang.CalendarHeaderNew;
		this.delbut.style.display="none";
		this.calendar_id.value = 0;

		this.calendar_subject.value = '';
		this.calendar_subject.focus();

		var color = this.getColor();
		var color_header = getNumberOfColor(color);
		this.SelectColorForNewCalendar(color, color_header, $('color_'+color));
		this.calendar_description.value = '';
	},

	CalendarFormCorrect : function(obj) {
		removeQuickMenu();
		setMaskHeight();
		var idc = obj['calendar_id'];
		var calendar_obj = mycache_c.calendars[idc];

		this.delbut.style.display = "";
		this.calendar_id.value = idc;
		this.calendar_window.style.display='block'; 
		if(SafariDetect().isSafari) { 
			this.calendar_form.style.top = window.innerHeight / 2 + 'px';
		};
		this.window_header.innerHTML = Lang.CalendarHeaderEdit;
		var color_number = calendar_obj['calendar_color'];
		var color_header = getNumberOfColor(color_number);
		this.SelectColorForNewCalendar(color_number, color_header,$('color_'+color_number));
		this.calendar_subject.value = calendar_obj['calendar_name'];
		this.calendar_subject.focus();
		this.calendar_description.value = calendar_obj['calendar_description'];
	},
	CalendarFormDelete : function(id_calendar) {
		if (id_calendar == undefined) {
			var id_calendar = Number(this.calendar_id.value);
		} else {
			id_calendar = Number(id_calendar);
		};
		if (id_calendar == undefined || id_calendar == "") return;

		var calendar_data = mycache_c.calendars[id_calendar];
		if (calendar_data == undefined) {
			this.calendar_window.style.display = 'none';
			return;
		};
		this.confirm_window.style.display='block';
		if (confirm(Lang.ConfirmDeleteCalendar + " "+calendar_data['calendar_name']+"?")) {
			ShowInfo(Lang.InfoDeleting);
			this.confirm_window.style.display='none';
			var req = getXMLHTTPRequest();
			var res = '';
			var url = processing_url+'?action=delete_calendar&calendar_id=' + id_calendar+'&nocache=' + Math.random();

			if (req) {
				try {
					req.open("GET",url,false);
					req.send(null);
					res = req.responseText;
				} catch(e) { };

				var calendar = res.parseJSON();
				if (!servErr(calendar,Lang.ErrorDeleteCalendar)) {
					if (calendar['calendar_id'] != 'undefined') {
						var calendar_obj = mycache_c.calendars[calendar['calendar_id']];
						if (calendar_obj != undefined) {
							deleteCalendarElement(calendar_obj);
							cmScroll_resize();
							calendarInManager.RefreshCalendarSelector(mydate.getDate(), mydate.getMonth()+1, mydate.getFullYear());
							ReRenderMonthly();
						}
					}
				}
			};
			HideInfo();
		} else {
			this.confirm_window.style.display='none';
			return;
		};
		this.calendar_window.style.display = 'none';
		//HideInfo();
	},
	CalendarFormCancel : function() {
		this.calendar_window.style.display='none';
	},
	SaveFormOnEnter : function(ev) {
		var ev = (ev) ? ev : window.event;
		if(ev.keyCode == 13) this.CalendarFormSave();
	},
	CalendarFormSave : function() {
		ShowInfo(Lang.InfoSaving);

		this.calendar_subject.value = Trim(this.calendar_subject.value);
		this.calendar_description.value = Trim(this.calendar_description.value);
		var id_cal = this.calendar_id.value;
		var subject = encodeURIComponent(this.calendar_subject.value.substr(0,50));
		var description = encodeURIComponent(this.calendar_description.value.substr(0,255));

		if (subject == ''){
			alert(Lang.WarningCalendarNameBlank);
			this.calendar_subject.focus();
			return;
		};

		var req = getXMLHTTPRequest();
		var res = '';
		if (this.calendar_color_number.value != '0') {
			var color = this.calendar_color_number.value;
		} else {
			if (id_cal != 0){
				var row = mycache_c.calendars[id_cal];
				var color = row['calendar_color'];
			} else {
				var color = this.getColor();
			}
		};

		mycache_c.clr[color] = color;
		var url = processing_url;
		var params = url+'?action=update_calendar&calendar_id=' + id_cal + '&name=' + subject + '&content=' + description +'&color_id=' + color+'&nocache=' + Math.random();

		if (req) {
			try {
				req.open("GET",params,false);
				req.send(null);
				res = req.responseText;
			} catch(e) { };

			var calendar = res.parseJSON();
			if (!servErr(calendar,Lang.ErrorLoadCalendar)) {
				var calendar_id = calendar["calendar_id"];
				var calendar_color = calendar["calendar_color"];
				if (calendar_id != undefined) {
					var calendar_cahe_data = mycache_c.calendars[calendar_id];
					if (calendar_cahe_data != undefined) {
						for (var j in  calendar) {
							calendar_cahe_data[j]=calendar[j];
						};
					} else {
						mycache_c.calendars[calendar_id] = calendar;
						mycache_c.calendars[calendar_id]["publication_hash"] = null;
						mycache_c.calendars[calendar_id]["publication_level"] = null;
						mycache_c.calendars[calendar_id]["sharing_level"] = null;
						mycache_c.calendars[calendar_id]["shares"] = new Array();
					};
				};
				if (this.calendar_id.value == 0){
					render_show_calendar($('my_calendars'), calendar);
					cmScroll_resize();
				} else {
					var CalText = $('calendar_'+calendar_id+'_text');
					CalText.innerHTML = HtmlEncode(this.calendar_subject.value);
					CalText.title = this.calendar_subject.value;
					changeColorContainer(calendar_id, calendar_color);
				}
			}
		};
		this.calendar_window.style.display = 'none';
		HideInfo();
	},
	getColor : function()
	{
		var res = new Array();
		var cnt = 1;
		var calendar = mycache_c.clr;
		for(var c = 1; c < 13; c++)
		{
			if(calendar != undefined && calendar[c] != c) res[cnt++] = c;
		};
		if(res[1] == undefined)
		{
			mycache_c.clr = new Array;
			res[1] = 1;
		};
		return res[1];
	}
}
function getMainURL() {
	var main_url = String(document.location);
	main_url = main_url.substring(0,main_url.lastIndexOf("/"));
	return main_url;
}