<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the proprietary AfterLogic Computer License (LICENSE.txt)
 * 
 */

	define('BUTTONTYPE_NEWMESSAGE', 1);
	define('BUTTONTYPE_CHECKMAIL', 2);
	define('BUTTONTYPE_FORWARD', 3);
	define('BUTTONTYPE_DELETE', 4);
	define('BUTTONTYPE_SAVE', 5);
	define('BUTTONTYPE_PRINT', 6);
	define('BUTTONTYPE_SEND', 12);
	
	define('BUTTONTYPE_RELOADFOLDER', 10);
	define('BUTTONTYPE_EMPTYTRASH', 11);
	
	define('BUTTONTYPE_BACK', 14);
	
	define('BUTTONTYPE_SPAM', 15);
	define('BUTTONTYPE_NOTSPAM', 16);
	
	define('BUTTONTYPE_NEWGROUP', 7);
	define('BUTTONTYPE_NEWCONTACT', 8);
	define('BUTTONTYPE_IMPORTCONTACTS', 9);
	
	define('BUTTONTYPE_TEST', 99);

	class ToolbarPanel
	{
		/**
		 * @var BaseProcessor
		 */
		var $_proc;
		
		/**
		 * @var PageBuilder
		 */
		var $_pagebuilder;
			
		/**
		 * @var AccounSelectDiv
		 */
		var $_accountSelect;
		
		/**
		 * @var ButtonToolBar
		 */
		var $_buttontoolbar = null;
		
		/**
		 * @param PageBuilder $pageBuilder
		 * @return ToolbarPanel
		 */
		function ToolbarPanel(&$pagebuilder)
		{
			$this->_pagebuilder = &$pagebuilder;
			$this->_proc =& $pagebuilder->_proc;
			$this->_accountSelect = new AccountSelectDiv($pagebuilder);
			
			$screen = $this->_proc->sArray[SCREEN];
			if ($screen == SET_COMMON || $screen == SET_ACCOUNT_PROF || $screen == SET_ACCOUNT_ADDACC ||
				$screen == SET_ACCOUNT_FILTERS || $screen == SET_ACCOUNT_SIGNATURE || $screen == SET_ACCOUNT_AUTORESPONDER ||
				$screen == SET_ACCOUNT_MFOLDERS ||  $screen == SET_CONTACTS || $screen == SCREEN_SETTINGS)
			{}
			else 
			{
				$this->_buttontoolbar = new ButtonToolBar($pagebuilder);
			}
		}
		
		function ToHTML()
		{
			$mailClassName = 'wm_accountslist_email';
			$contactsClassName = 'wm_accountslist_contacts';
			$settingsClassName = 'wm_accountslist_settings';
			switch ($this->_proc->sArray[SCREEN])
			{
				case SCREEN_SETTINGS:
				case SET_ACCOUNT_PROF:	
				case SET_ACCOUNT_FILTERS:	
				case SET_ACCOUNT_SIGNATURE:	
				case SET_ACCOUNT_MFOLDERS:	
				case SET_ACCOUNT_ADDACC:
				case SET_CONTACTS:	
				case SET_COMMON:
					$settingsClassName = 'wm_accountslist_settings wm_active_tab';
					break;
				case SCREEN_CONTACTS:
					$contactsClassName = 'wm_accountslist_contacts wm_active_tab';
					break;
				default:
				case SCREEN_NEWOREDIT:
				case SCREEN_FULLSCREEN:
				case SCREEN_MAILBOX:
					$mailClassName = 'wm_accountslist_email wm_active_tab';
					break;
			}
			
			$hideSettings = '
				<span class="'.$settingsClassName.'">
					<a href="'.BASEFILE.'?'.SCREEN.'='.SCREEN_SETTINGS.'">'.JS_LANG_Settings.'</a>
				</span>';
			
			$hideContacts = (!$this->_proc->settings->AllowContacts) ? '' :
				'<span class="'.$contactsClassName.'">
					<a href="'.BASEFILE.'?'.SCREEN.'='.SCREEN_CONTACTS.'">'.JS_LANG_Contacts.'</a>
				</span>';
				
			$buttonstool = ($this->_buttontoolbar) ? $this->_buttontoolbar->ToHTML() : '';
			
			return '
		<table class="wm_accountslist" id="accountslist">
		  <tr>
			<td>
			'
			.
			$this->_accountSelect->doTitle($mailClassName)
			.
			$hideContacts
			.
			'	<span class="wm_accountslist_logout">
					<a href="'.LOGINFILE.'?mode=logout" onclick="EraseCookie(\'awm_autologin_data\'); EraseCookie(\'awm_autologin_id\');">'.JS_LANG_Logout.'</a>
				</span>
				'
				.
				$hideSettings
				.
				'
			</td>
		  </tr>
		</table>'. $buttonstool;
			
		}
	}

	class AccountSelectDiv
	{
		/**
		 * @var PageBuilder
		 */
		var $_pagebuilder;
		
		/**
		 * @var array
		 */
		var $_accounts;
		
		/**
		 * @param PageBuilder $pageBuilder
		 * @return AccounSelectDiv
		 */
		function AccountSelectDiv(&$pagebuilder)
		{
			$this->_pagebuilder = &$pagebuilder;
			$this->_accounts = $this->_pagebuilder->_proc->GetAccounts();
			
			$this->ToHideDiv();
			if ($this->Count() > 1)
			{		
				$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_1"), document.getElementById("popup_control_1"), "wm_account_menu", document.getElementById("popup_replace_1"), document.getElementById("popup_replace_1"), "", "", "", "");');
			}
		}
		
		function Count()
		{
			return count($this->_accounts);
		}
		
		function doTitle($className)
		{
			$_one = ($this->Count() < 2);
			$class = $_one ? 'wm_accountslist_selection_none' : 'wm_accountslist_selection wm_control';
	
			$_temp = ($_one) ? '' :
			'
onmouseover="this.className=\'wm_accountslist_selection_over wm_control\'"
onmousedown="this.className=\'wm_accountslist_selection_press wm_control\'"
onmouseup="this.className=\'wm_accountslist_selection_over wm_control\'"
onmouseout="this.className=\'wm_accountslist_selection wm_control\'"			
			';
			
			return '
				<span class="'.$className.'" id="popup_replace_1">
					<a href="'.BASEFILE.'?'.SCREEN.'='.SCREEN_MAILBOX.'">'.ConvertUtils::WMHtmlSpecialChars($this->_accounts[$this->_pagebuilder->_proc->account->Id][4]).'</a>
				</span>			
				<div class="'.$class.'" id="popup_control_1"
'.$_temp.'
				></div>';
		}
		
		function ToHideDiv()
		{
			$out = '';
			if ($this->Count() > 1)
			{
				$out .= '<div class="wm_hide" id="popup_menu_1" >';
				foreach ($this->_accounts as $acct_id => $acctArray)
				{
					if ($acct_id != $this->_pagebuilder->_proc->account->Id)
					{
						$out .= '<div class="wm_account_item" onclick="document.location.replace(\''.BASEFILE.'?'.SCREEN.'='.SCREEN_MAILBOX.'&'.CHANGE_ACCID.'='.$acct_id.'\');"
								onmouseover="this.className=\'wm_account_item_over\';" onmouseout="this.className=\'wm_account_item\';">'.ConvertUtils::WMHtmlSpecialChars($acctArray[4]).'</div>';	
					}
				}
				$out.= '</div>';
			}
			
			$this->_pagebuilder->AddHideDiv($out);
		}
	}

	class ButtonToolBar
	{
		
		/**
		 * @var PageBuilder
		 */
		var $_pagebuilder;
		
		/**
		 * @var array
		 */
		var $_buttons;
	
		/**
		 * @var SearchFormClass
		 */
		var $_searchform = null; 
		
		/**
		 * @param PageBuilder $pagebuilder
		 * @return ButtonToolBar
		 */
		function ButtonToolBar(&$pagebuilder)
		{
			$this->_pagebuilder = &$pagebuilder; 
			$screen = $this->_pagebuilder->_proc->sArray[SCREEN];
			
			if (!$this->_pagebuilder->_proc->settings->ShowTextLabels)
			{
				$this->_pagebuilder->AddInitText('
var ImgKey = document.getElementById("checkImgId");
var isDisplay;
if(ImgKey) {
	if (isDisplay = ReadStyle(ImgKey, "display"))	{
		if (isDisplay && isDisplay == "none") {
			var toolbartable = document.getElementById("toolbar");
			if (toolbartable) {
				var spans = toolbartable.getElementsByTagName("span");
				var i, c;
				if (spans) {
					for (i = 0, c = spans.length; i < c; i++) {
						spans[i].className = "";
					}
				}
			}
		}
	}
}
				');
			}
			
			switch ($screen)
			{
				default:
				case SCREEN_MAILBOX:
					$this->AddSimpleButton(BUTTONTYPE_NEWMESSAGE);
					$this->AddSimpleButton(BUTTONTYPE_CHECKMAIL);
					
					if ($this->_pagebuilder->_proc->account->MailProtocol != MAILPROTOCOL_POP3) {
							$this->AddSimpleButton(BUTTONTYPE_RELOADFOLDER);
					}
					
					if ($this->_pagebuilder->_proc->currentFolder && $this->_pagebuilder->_proc->currentFolder->Type != FOLDERTYPE_Drafts)
					{
						$this->_buttons[] = new ReplyButton($pagebuilder); 
						$this->AddSimpleButton(BUTTONTYPE_FORWARD);
					}
					
					if ($this->_pagebuilder->_proc->currentFolder && 
						$this->_pagebuilder->_proc->currentFolder->SyncType == FOLDERSYNC_DirectMode)
					{
						if ($this->_pagebuilder->_proc->account->MailProtocol == MAILPROTOCOL_IMAP4)
						{
							$this->_buttons[] = new MarkButton($pagebuilder);
							$this->_buttons[] = new MoveToFolderButton($pagebuilder); 							
						}
						else 
						{
							$this->_buttons[] = new MoveToFolderButton($pagebuilder); 							
						}
					}
					else
					{
						$this->_buttons[] = new MarkButton($pagebuilder);
						$this->_buttons[] = new MoveToFolderButton($pagebuilder); 
					}
					
					if (USEIMAPTRASH || $this->_pagebuilder->_proc->account->MailProtocol == MAILPROTOCOL_POP3)
					{
						$this->_buttons[] = new POP3_Delete($pagebuilder);	
					}
					else
					{
						$this->_buttons[] = new IMAP_Delete($pagebuilder);	
					}
					
					if ($this->_pagebuilder->_proc->account->MailProtocol == MAILPROTOCOL_WMSERVER)
					{
						if ($this->_pagebuilder->_proc->currentFolder &&
							$this->_pagebuilder->_proc->currentFolder->Type != FOLDERTYPE_Drafts &&
							$this->_pagebuilder->_proc->currentFolder->Type != FOLDERTYPE_SentItems
						)
						{ 
							if ($this->_pagebuilder->_proc->currentFolder->Type == FOLDERTYPE_Spam)
							{
								$this->AddSimpleButton(BUTTONTYPE_NOTSPAM);
							}
							else
							{
								$this->AddSimpleButton(BUTTONTYPE_SPAM);	
							}
						}
					}
					
					if ($screen != SCREEN_NEWOREDIT)
					{
						if ($this->_pagebuilder->_proc->currentFolder)
						{
							if ($this->_pagebuilder->_proc->currentFolder->SyncType != FOLDERSYNC_DirectMode)
							{
								$this->_searchform = new SearchFormClass($pagebuilder); 
							}
						}						
						else
						{
							$this->_searchform = new SearchFormClass($pagebuilder); 
						}
					}
					
					break;
					
				case SCREEN_CONTACTS:
					$this->AddSimpleButton(BUTTONTYPE_BACK);
					$this->AddSimpleButton(BUTTONTYPE_NEWMESSAGE);
					$this->AddSimpleButton(BUTTONTYPE_NEWCONTACT);
					$this->AddSimpleButton(BUTTONTYPE_NEWGROUP);
					
					$this->_buttons[] = new AddContactToButton($pagebuilder); 
					
					$this->AddSimpleButton(BUTTONTYPE_DELETE);
					$this->AddSimpleButton(BUTTONTYPE_IMPORTCONTACTS);
					
					$this->_searchform = new SearchFormContactsClass($pagebuilder); 
					break;
				case SCREEN_FULLSCREEN:
					$this->AddSimpleButton(BUTTONTYPE_BACK);
					$this->AddSimpleButton(BUTTONTYPE_NEWMESSAGE);

					$this->_buttons[] = new ReplyButton($pagebuilder); 
					$this->AddSimpleButton(BUTTONTYPE_FORWARD);
					
					$this->AddSimpleButton(BUTTONTYPE_PRINT);
					$this->AddSimpleButton(BUTTONTYPE_SAVE);
					$this->AddSimpleButton(BUTTONTYPE_DELETE);
					
					break;
				case SCREEN_NEWOREDIT:
					$this->AddSimpleButton(BUTTONTYPE_BACK);
					$this->AddSimpleButton(BUTTONTYPE_SEND);
					$this->AddSimpleButton(BUTTONTYPE_SAVE);
					$this->_buttons[] = new PriorityButton($pagebuilder); 
					break;
			}
			
		}
		
		/**
		 * @param int $type
		 */
		function AddSimpleButton($type)
		{
			$this->_buttons[] = new ToolbarButton($this->_pagebuilder, $type);
		}
		
		/**
		* @return string
		*/
		function ButtonsToHtml()
		{
			$out = '';
		
			for ($i = 0, $c = count($this->_buttons); $i < $c; $i++)
			{
				$button = &$this->_buttons[$i];
				$out .= $button->ToHTML();
			}
		
			return $out;
		} 
		
		function ToHTML()
		{
			$search = ($this->_searchform) ? $this->_searchform->ToHTML() : '';
			return '
<table class="wm_toolbar" id="toolbar">
  <tr>
	<td>'
		.
		$this->ButtonsToHtml()
		.
		$search
		.
		'
	</td>
  </tr>
</table>
'; 
		}
		
	}

class SearchFormClass
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @var string
	 */
	var $_hidePart = '';
	
	function SearchFormClass(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->_hidePart = $this->ToHideDiv();
		$this->_pagebuilder->AddJSText('var SearchForm;');
		$this->_pagebuilder->AddInitText('
SearchForm = new CSearchForm(document.getElementById("search_form"), document.getElementById("search_small_form"), document.getElementById("search_control_div_down"), document.getElementById("search_control_div_up"), "search_form", document.getElementById("bigLookFor"), document.getElementById("smallLookFor"), "'.$this->_pagebuilder->SkinName().'");
SearchForm.Show();
		');
		$this->_pagebuilder->_top->AddOnClick('SearchForm.checkVisibility(event, Browser.Mozilla);');
	}
	
	/**
	 * @param FolderCollection $folderCollection
	 * @param int $selectId
	 * @return string
	 */
	function CreateFolderTree($folderCollection, $selectId = -1)
	{
		$out = '';
		for ($i = 0, $c = $folderCollection->Count(); $i < $c; $i++)
		{
			$folder = &$folderCollection->Get($i);
			
			$foldername = '';
			
			if (ConvertUtils::IsLatin($folder->Name))
			{
				$foldername = ConvertUtils::ConvertEncoding($folder->Name,
												CPAGE_UTF7_Imap,
												$this->_pagebuilder->_proc->account->GetUserCharset());
			}
			else
			{
				$foldername = ConvertUtils::ConvertEncoding($folder->Name,
												$this->_pagebuilder->_proc->account->DefaultIncCharset,
												$this->_pagebuilder->_proc->account->GetUserCharset());
			}

			if (!$folder->Hide && $folder->SyncType != FOLDERSYNC_DirectMode)
			{
				$isSelect = ($folder->IdDb == $selectId) ? 'selected="selected"' : '';
				$out .= '<option value="'.$folder->IdDb.'" '.$isSelect.'>'.str_repeat('&nbsp;', ((int) $folder->Level) * 3);
				
				switch ($folder->Type)
				{
					default:
					case FOLDERTYPE_Custom:		$out .= ConvertUtils::WMHtmlSpecialChars($foldername); break;					
					case FOLDERTYPE_Inbox:		$out .= FolderInbox; break;
					case FOLDERTYPE_Drafts:		$out .= FolderDrafts; break;
					case FOLDERTYPE_SentItems:	$out .= FolderSentItems; break;
					case FOLDERTYPE_Spam:		$out .= FolderSpam; break;
					case FOLDERTYPE_Virus:		$out .= FolderQuarantine; break;
					case FOLDERTYPE_Trash:		$out .= FolderTrash; break;
				}				
				
				$out .= '</option>'."\r\n";
				
				if ($folder->SubFolders != null && $folder->SubFolders->Count() > 0)
				{
					$out .= $this->CreateFolderTree($folder->SubFolders, $selectId);
				}
			}
		}
		return $out;
	}
	
	function ToHTML()
	{
		$currentFolderId = ($this->_pagebuilder->_proc->currentFolder) ? $this->_pagebuilder->_proc->currentFolder->IdDb : -1;
		$text = (isset($this->_pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT])) ? $this->_pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT] : '';
		return '
<div class="wm_toolbar_search_item" style="margin-left: 0px;" id="search_control_div_down" ><span
	class="wm_search_icon" style="background-position: -640px 0px;">&nbsp;</span></div
><div class="wm_hide" style="margin-left: 0px;" id="search_control_div_up"><span
	class="wm_search_icon" style="background-position: -680px 0px;">&nbsp;</span
></div><div
class="wm_toolbar_search_item" onmouseover="this.className=\'wm_toolbar_search_item_over\'" 
onmouseout="this.className=\'wm_toolbar_search_item\'" id="search_small_form" style="margin-right: 0px;">
	<form action="?'.S_GETMODE.'=mini" method="POST" id="searchformmini">
		<input type="hidden" id="qfolder" name="qfolder"  value="'.$currentFolderId.'"/>
		<input type="text" id="smallLookFor" name="smallLookFor" class="wm_search_input" value="'.ConvertUtils::AttributeQuote($text).'" >
		<span class="wm_search_icon" style="background-position: -560px 0px;" onclick="document.getElementById(\'searchformmini\').submit();">&nbsp</span>
	</form>
</div>	
'. $this->_hidePart;
	}
	
	function ToHideDiv()
	{
		$currentFolderId = ($this->_pagebuilder->_proc->currentFolder) ? $this->_pagebuilder->_proc->currentFolder->IdDb : -1;
		return '
<div class="wm_hide" id="search_form">
<form action="?'.S_GETMODE.'=big" method="POST" id="searchformbig">
	<table>
		<tr>
			<td class="wm_search_title">
				'.JS_LANG_LookFor.'
			</td>
			<td class="wm_search_value">
				<input type="text" id="bigLookFor" name="bigLookFor" class="wm_search_input" value="" />
				<span class="wm_search_icon" onclick="document.getElementById(\'searchformbig\').submit();" style="background-position: -560px 0px;">&nbsp;</span>
			</td>
		</tr>
		<tr>
			<td class="wm_search_title">
				'.JS_LANG_SearchIn.'
			</td>
			<td class="wm_search_value">
				<select name="qfolder">
					<option value="-2" selected="selected">'.JS_LANG_AllMailFolders.'</option>
					'.
					$this->CreateFolderTree($this->_pagebuilder->_proc->GetFolders(), $currentFolderId)
					.'
				</select>
			</td>
		</tr>
		<tr>
			<td class="wm_search_value" colspan="2">
				<input type="radio" name="qmmode" id="qmmode1" value="onlyheaders" checked="checked" class="wm_checkbox" />
				<label for="qmmode1">'.JS_LANG_QuickSearch.'</label>
			</td>
		</tr>
  		<tr>
  			<td class="wm_search_value" colspan="2">
  				<input type="radio" name="qmmode" id="qmmode2" value="allmessage" class="wm_checkbox" />
  				<label for="qmmode2">'.JS_LANG_SlowSearch.'</label>
  			</td>
  		</tr>
	</table>
</form>
</div>';
	}
	
} 

class ToolbarButton
{
	/**
	 * @var int
	 */
	var $_x;
	
	/**
	 * @var int
	 */
	var $_y;
	
	/**
	 * @var string
	 */
	var $_onclick;
	
	/**
	 * @var string
	 */
	var $_title;
	
	/**
	 * @var bool
	 */
	var $_withText = true;
	
	var $_buttonType;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @param int $buttonType
	 * @return ToolbarButton
	 */
	function ToolbarButton($pagebuilder, $buttonType)
	{
		$this->_withText = $pagebuilder->_proc->settings->ShowTextLabels;
		$this->_buttonType = $buttonType;
		
		switch ($buttonType)
		{
			default:
			case BUTTONTYPE_NEWMESSAGE:
				$this->_x = 0;
				$this->_y = 0;
				$this->_onclick = 'DoNewMessageButton();';
				$this->_title = JS_LANG_NewMessage;
				break;
			case BUTTONTYPE_CHECKMAIL:
				$this->_x = -40;
				$this->_y = 0;
				$this->_onclick = 'CheckMail.Start();';
				$this->_title = JS_LANG_CheckMail;
				break;
			case BUTTONTYPE_FORWARD:
				$this->_x = -200;
				$this->_y = 0;
				$this->_onclick = 'DoForwardButton();';
				$this->_title = JS_LANG_Forward;
				break;
			case BUTTONTYPE_DELETE:
				$this->_x = -320;
				$this->_y = 0;
				$this->_imgfile = 'delete.gif';
				$this->_onclick = 'DoDeleteButton();';
				$this->_title = JS_LANG_Delete;
				$this->_class = 'wm_menu_delete_img';
				break;
			case BUTTONTYPE_EMPTYTRASH:
				$this->_x = -80;
				$this->_y = -40;
				$fid = ($pagebuilder->_proc->currentFolder) ? $pagebuilder->_proc->currentFolder->IdDb : '-1';
				$this->_onclick = 'confirm(\''.JS_LANG_ConfirmAreYouSure.'\') ? document.location=\''.ACTIONFILE.'?action=delete&req=trash&f='.$fid.'\' : \'\';';
				$this->_title = JS_LANG_EmptyTrash;
				break;
			case BUTTONTYPE_SAVE:
				$this->_x = -440;
				$this->_y = 0;
				$this->_onclick = 'DoSaveButton();';
				$this->_title = JS_LANG_SaveMessage;
				break;
			case BUTTONTYPE_SEND:
				$this->_x = -40;
				$this->_y = -40;
				$this->_onclick = 'DoSendButton();';
				$this->_title = JS_LANG_SendMessage;
				$this->_class = 'wm_menu_send_message_img';
				break;	
			case BUTTONTYPE_PRINT:
				$this->_x = -240;
				$this->_y = -40;
				$this->_onclick = 'DoPrintButton();';
				$this->_title = JS_LANG_Print;
				break;
			case BUTTONTYPE_RELOADFOLDER:
				$this->_x = -80;
				$this->_y = -0;
				$this->_onclick = 'DoReloadFolderButton();';
				$this->_title = JS_LANG_ReloadFolders;
				break;
			case BUTTONTYPE_BACK:
				$this->_x = -0;
				$this->_y = -40;
				$this->_onclick = 'document.location=\''.BASEFILE.'?'.SCREEN.'='.SCREEN_MAILBOX.'\'';
				$this->_title = BackToList;
				break;
				
			/* spam */
			case BUTTONTYPE_SPAM:
				$this->_x = -480;
				$this->_y = -0;
				$this->_onclick = 'DoSpamButton(true);';
				$this->_title = SpamButton;
				break;
				
			case BUTTONTYPE_NOTSPAM:
				$this->_x = -520;
				$this->_y = -0;
				$this->_onclick = 'DoSpamButton(false)';
				$this->_title = NotSpamButton;
				break;
				
			/* contacts */
			case BUTTONTYPE_NEWGROUP:
				$this->_x = -480;
				$this->_y = -40;
				$this->_onclick = 'document.location=\''.BASEFILE.'?'.CONTACT_MODE.'='.G_NEW.'\'';
				$this->_title = JS_LANG_NewGroup;
				break;
			case BUTTONTYPE_NEWCONTACT:
				$this->_x = -440;
				$this->_y = -40;
				$this->_onclick = 'document.location=\''.BASEFILE.'?'.CONTACT_MODE.'='.C_NEW.'\'';
				$this->_title = JS_LANG_NewContact;
				break;
			case BUTTONTYPE_IMPORTCONTACTS:
				$this->_x = -560;
				$this->_y = -40;
				$this->_onclick = 'document.location=\''.BASEFILE.'?'.CONTACT_MODE.'='.C_IMPORT.'\'';
				$this->_title = JS_LANG_ImportContacts;
				break;	
		}
	}
	
	/**
	 * @return string
	 */
	function ToHTML()
	{
		$idForCheck = ($this->_buttonType == BUTTONTYPE_SEND || $this->_buttonType == BUTTONTYPE_NEWMESSAGE) 
			? 'id="checkImgId"' : '';
		$textClass = ($this->_withText) ? '' : 'wm_hide';
		return '
<div class="wm_toolbar_item" onmouseover="this.className=\'wm_toolbar_item_over\'" onmouseout="this.className=\'wm_toolbar_item\'"
	onclick="'.$this->_onclick.'">
		<span '.$idForCheck.' class="wm_toolbar_icon" style="background-position: '.$this->_x.'px '.$this->_y.'px;" title="'.ConvertUtils::AttributeQuote($this->_title).'">&nbsp;</span><span class="'.$textClass.'">'.$this->_title.'</span>
</div>';
	}
	
}

class AddContactToButton
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return AddContactToButton
	 */
	function AddContactToButton(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->ToHideDiv();
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_7"), document.getElementById("popup_control_7"), "wm_popup_menu", document.getElementById("popup_control_7"), document.getElementById("popup_control_7"), "wm_toolbar_item", "wm_toolbar_item_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		return '
<div class="wm_toolbar_item" id="popup_control_7"> 
	<span class="wm_toolbar_icon" style="background-position: -520px -40px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_AddContactsTo).'">&nbsp;</span><span
		class="'.$textClass.'">'.JS_LANG_AddContactsTo.'</span><span
		class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
</div>
		';
	}
	
	/**
	 * @return String
	 */
	function CreateGroupsHtml()
	{
		$out = '';
		$groupNames = &$this->_pagebuilder->_proc->db->SelectUserAddressGroupNames();
		foreach ($groupNames as $id => $name)
		{
			$out .= '<div onclick="AddContactsToGroup('.$id.', \''.
									ConvertUtils::AttributeQuote(
										ConvertUtils::ClearJavaScriptString($name, '\'')
										).'\');" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">'.ConvertUtils::WMHtmlSpecialChars($name).'</div>';
		}
		return $out;
	}
	
	function ToHideDiv()
	{
		$this->_pagebuilder->AddHideDiv('
<div class="wm_hide" id="popup_menu_7">'
	.
	$this->CreateGroupsHtml()
	.
	'
</div>');
	}
}

class MoveToFolderButton
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return MoveToFolderButton
	 */
	function MoveToFolderButton(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->ToHideDiv();
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_2"), document.getElementById("popup_control_2"), "wm_popup_menu", document.getElementById("popup_control_2"), document.getElementById("popup_control_2"), "wm_toolbar_item", "wm_toolbar_item_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		return '
<div class="wm_toolbar_item" id="popup_control_2"> 
	<span class="wm_toolbar_icon" style="background-position: -280px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MoveToFolder).'">&nbsp;</span><span
		class="'.$textClass.'">'.JS_LANG_MoveToFolder.'</span><span
		class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
</div>
		';
	}
	
	/**
	 * @param FolderCollection $folderCollection
	 * @return String
	 */
	function CreateFolderTree($folderCollection)
	{
		$out = '';
		for ($i = 0, $c = $folderCollection->Count(); $i < $c; $i++)
		{
			$folder = &$folderCollection->Get($i);
			
			if ($folder->Hide) continue;
			if ($folder->SyncType == FOLDERSYNC_DirectMode && $this->_pagebuilder->_proc->account->MailProtocol == MAILPROTOCOL_POP3) continue;
			
			$foldername = '';
			
			if (ConvertUtils::IsLatin($folder->Name))
			{
				$foldername = ConvertUtils::ConvertEncoding($folder->Name,
												CPAGE_UTF7_Imap,
												$this->_pagebuilder->_proc->account->GetUserCharset());
			}
			else
			{
				$foldername = ConvertUtils::ConvertEncoding($folder->Name,
												$this->_pagebuilder->_proc->account->DefaultIncCharset,
												$this->_pagebuilder->_proc->account->GetUserCharset());
			}
			
			$out .= '<div onclick="MoveToFolder(\''.$folder->IdDb.'\');" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">'.str_repeat('&nbsp;', ((int) $folder->Level) * 4);
			switch ($folder->Type)
			{
				default:
				case FOLDERTYPE_Custom:		$out .= ConvertUtils::WMHtmlSpecialChars($foldername); break;					
				case FOLDERTYPE_Inbox:		$out .= FolderInbox; break;
				case FOLDERTYPE_Drafts:		$out .= FolderDrafts; break;
				case FOLDERTYPE_SentItems:	$out .= FolderSentItems; break;
				case FOLDERTYPE_Spam:		$out .= FolderSpam; break;
				case FOLDERTYPE_Virus:		$out .= FolderQuarantine; break;
				case FOLDERTYPE_Trash:		$out .= FolderTrash; break;
			}
			
			$out .= '</div>';
			
			if ($folder->SubFolders != null && $folder->SubFolders->Count() > 0)
			{
				$out .= $this->CreateFolderTree($folder->SubFolders);
			}				
		}
		return $out;
	}
	
	function ToHideDiv()
	{
		$this->_pagebuilder->AddHideDiv('
<div class="wm_hide" id="popup_menu_2">'
	.
	$this->CreateFolderTree($this->_pagebuilder->_proc->GetFolders())
	.
	'
</div>');
	}
}

class MarkButton
{
	
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return MarkButton
	 */
	function MarkButton(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->isSearch = (isset($pagebuilder->_proc->sArray[SEARCH_ARRAY]) && strlen($pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT]) > 0);
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_3"), document.getElementById("popup_control_3"), "wm_popup_menu", document.getElementById("popup_replace_3"), document.getElementById("popup_title_3"), "wm_tb", "wm_tb_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		$temp = ($this->isSearch) ? '' : '
		<div class="wm_menu_separate"></div>
	<div onclick="document.location=\''.ACTIONFILE.'?action=groupoperation&req=mark_all_read&f='.$this->_pagebuilder->_proc->sArray[FOLDER_ID].'\'" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -80px -120px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkAllRead).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkAllRead.'</span>
	</div>
	<div onclick="document.location=\''.ACTIONFILE.'?action=groupoperation&req=mark_all_unread&f='.$this->_pagebuilder->_proc->sArray[FOLDER_ID].'\'" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -120px -120px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkAllUnread).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkAllUnread.'</span>
	</div>';
		
		$_rtl_text = $_not_rtl = '
	<div class="wm_toolbar_item" id="popup_control_3">
		<span class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
	</div>';	
		if ($this->_pagebuilder->_rtl)
		{ 
			$_not_rtl = '';
		}
		else
		{
			$_rtl_text = '';
		}
		
		return '
<div id="popup_replace_3" class="wm_tb">
	'.$_rtl_text.'
	<div class="wm_toolbar_item" id="popup_title_3" onclick="DoReadMessages();">
		<span class="wm_toolbar_icon" style="background-position: -240px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkAsRead).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkAsRead.'</span>
	</div>
	'.$_not_rtl.'
</div>
<div class="wm_hide" id="popup_menu_3">
	<div onclick="DoUnReadMessages();" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -160px -120px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkAsUnread).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkAsUnread.'</span>
	</div>
	<div onclick="DoFlagMessages();" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: 0px -120px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkFlag).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkFlag.'</span>
	</div>
	<div onclick="DoUnFlagMessages();" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -40px -120px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_MarkFlag).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_MarkUnflag.'</span>
	</div>
	'.$temp.'
</div>
		';
	}	
					
}


class ReplyButton
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return ReplyButton
	 */
	function ReplyButton(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_4"), document.getElementById("popup_control_4"), "wm_popup_menu", document.getElementById("popup_replace_4"), document.getElementById("popup_title_4"), "wm_tb", "wm_tb_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$_rtl_text = $_not_rtl = '
	<div class="wm_toolbar_item" id="popup_control_4">
		<span class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
	</div>';	
		if ($this->_pagebuilder->_rtl)
		{ 
			$_not_rtl = '';
		}
		else
		{
			$_rtl_text = '';
		}
		
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		return '
<div id="popup_replace_4" class="wm_tb">
	'.$_rtl_text.'
	<div class="wm_toolbar_item" id="popup_title_4" onclick="DoReplyButton();">
		<span class="wm_toolbar_icon" style="background-position: -120px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_Reply).'">&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_Reply.'</span>
	</div>
	'.$_not_rtl.'
</div>
<div class="wm_hide" id="popup_menu_4">
	<div onclick="DoReplyAllButton();" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_control_icon" style="background-position: -160px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_ReplyAll).'">&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_ReplyAll.'</span>
	</div>
</div>
		';
	}	
} 

class IMAP_Delete
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @var bool
	 */
	var $isSearch = false;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return IMAP_Delete
	 */
	function IMAP_Delete(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->isSearch = (isset($pagebuilder->_proc->sArray[SEARCH_ARRAY]) && strlen($pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT]) > 0);
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_13"), document.getElementById("popup_control_13"), "wm_popup_menu", document.getElementById("popup_replace_13"), document.getElementById("popup_title_13"), "wm_tb", "wm_tb_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		$fid = ($this->_pagebuilder->_proc->currentFolder) ? $this->_pagebuilder->_proc->currentFolder->IdDb : '-1';
		$temp = ($this->isSearch) ? '' : 
		'<div onclick="confirm(\''.
			ConvertUtils::AttributeQuote(
				ConvertUtils::ClearJavaScriptString(JS_LANG_ConfirmAreYouSure, '\'')).'\') ? document.location=\''.ACTIONFILE.'?action=delete&req=purge&f='.$fid.'\' : \'\';" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -400px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_PurgeDeleted).'" >&nbsp;</span>
		<span class="'.$textClass.'">'.JS_LANG_PurgeDeleted.'</span>
	</div>';
		
		$_rtl_text = $_not_rtl = '
	<div class="wm_toolbar_item" id="popup_control_13">
		<span class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
	</div>';	
		if ($this->_pagebuilder->_rtl)
		{ 
			$_not_rtl = '';
		}
		else
		{
			$_rtl_text = '';
		}
				
		return '
<div id="popup_replace_13" class="wm_tb">
	'.$_rtl_text.'
	<div class="wm_toolbar_item" id="popup_title_13" onclick="DoDeleteButton();" >
		<span class="wm_toolbar_icon" style="background-position: -320px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_Delete).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_Delete.'</span>
	</div>
	'.$_not_rtl.'
</div>
<div class="wm_hide" id="popup_menu_13">
	<div onclick="DoUnDeleteButton();" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -360px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_Undelete).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_Undelete.'</span>
	</div>
	'.$temp.'
</div>
		';
	}	
} 

class POP3_Delete
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @var bool
	 */
	var $isSearch = false;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return POP3_Delete
	 */
	function POP3_Delete(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->isSearch = (isset($pagebuilder->_proc->sArray[SEARCH_ARRAY]) && strlen($pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT]) > 0);
		$this->_pagebuilder->AddInitText('PopupMenu.addItem(document.getElementById("popup_menu_delPop"), document.getElementById("popup_control_delPop"), "wm_popup_menu", document.getElementById("popup_replace_delPop"), document.getElementById("popup_title_delPop"), "wm_tb", "wm_tb_press", "wm_toolbar_item", "wm_toolbar_item_over");');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		$fc = $this->_pagebuilder->_proc->GetFolders();
		$fld = ($fc != null) ? $fc->GetFolderByType(FOLDERTYPE_Trash) : null;
		$fid = ($fld != null) ? $fld->IdDb : '-1';
		$onclick = 'confirm(\''.JS_LANG_ConfirmAreYouSure.'\') ? document.location=\''.ACTIONFILE.'?action=delete&req=trash&f='.$fid.'\' : \'\';';

		$_rtl_text = $_not_rtl = '
	<div class="wm_toolbar_item" id="popup_control_delPop">
		<span class="wm_control_icon" style="background-position: -720px 0px;">&nbsp;</span>
	</div>';	
		if ($this->_pagebuilder->_rtl)
		{ 
			$_not_rtl = '';
		}
		else
		{
			$_rtl_text = '';
		}
		
		return '
<div id="popup_replace_delPop" class="wm_tb">
	'.$_rtl_text.'
	<div class="wm_toolbar_item" id="popup_title_delPop" onclick="DoDeleteButton();" >
		<span class="wm_toolbar_icon" style="background-position: -320px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_Delete).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_Delete.'</span>
	</div>
	'.$_not_rtl.'
</div>
<div class="wm_hide" id="popup_menu_delPop">
	<div onclick="'.$onclick.'" class="wm_menu_item" onmouseover="this.className=\'wm_menu_item_over\';" onmouseout="this.className=\'wm_menu_item\';">
		<span class="wm_toolbar_icon" style="background-position: -440px 0px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_EmptyTrash).'" >&nbsp;</span><span
			class="'.$textClass.'">'.JS_LANG_EmptyTrash.'</span>
	</div>
</div>
		';
	}	
}

class PriorityButton
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @param PageBuilder $pagebuilder
	 * @return PriorityButton
	 */
	function PriorityButton(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		
		$this->_pagebuilder->AddInitText('
PriorityImg = document.getElementById("priority_img");
PriorityText = document.getElementById("priority_text");
PriorityInput = document.getElementById("priority_input");
		');
		
		$this->_pagebuilder->AddJSText('
var PriorityImg, PriorityText, PriorityInput;

function SetPriority(value)
{
	switch (value) {
		case 5:
			PriorityInput.value = 5;
			PriorityText.innerHTML = "'.JS_LANG_Low.'";
			PriorityImg.style.backgroundPosition = "-160px -40px";
		break;
		default:
		case 3:
			PriorityInput.value = 3;
			PriorityText.innerHTML = "'.JS_LANG_Normal.'";
			PriorityImg.style.backgroundPosition = "-200px -40px";
		break;
		case 1:
			PriorityInput.value = 1;
			PriorityText.innerHTML = "'.JS_LANG_High.'";
			PriorityImg.style.backgroundPosition = "-120px -40px";
		break;
	}
}

function ChangePriority()
{
	switch (PriorityInput.value) {
		case "5":
			SetPriority(3);
		break;
		case "3":
			SetPriority(1);
		break;
		case "1":
			SetPriority(5);
		break;
	}
}
		');
	}
	
	function ToHTML()
	{
		$textClass = ($this->_pagebuilder->_proc->settings->ShowTextLabels) ? '' : 'wm_hide';
		return '
<div onclick="ChangePriority();" class="wm_toolbar_item" onmouseover="this.className=\'wm_toolbar_item_over\';" onmouseout="this.className=\'wm_toolbar_item\';">
	<span id="priority_img" class="wm_toolbar_icon" style="background-position: -200px -40px;" title="'.ConvertUtils::AttributeQuote(JS_LANG_Importance).'" >&nbsp;</span><span
		id="priority_text" class="'.$textClass.'">'.JS_LANG_Normal.'</span>
</div>
		';
	}	
} 

class SearchFormContactsClass
{
	/**
	 * @var PageBuilder
	 */
	var $_pagebuilder;
	
	/**
	 * @var string
	 */
	var $_hidePart = '';
	
	function SearchFormContactsClass(&$pagebuilder)
	{
		$this->_pagebuilder = &$pagebuilder;
		$this->_hidePart = $this->ToHideDiv();
		$this->_pagebuilder->AddJSText('var SearchForm;');
		$this->_pagebuilder->AddInitText(
		'
SearchForm = new CSearchForm(document.getElementById("search_form"), document.getElementById("search_small_form"), document.getElementById("search_control_div_down"), document.getElementById("search_control_div_up"), "search_form", document.getElementById("bigLookFor"), document.getElementById("smallLookFor"), "'.$this->_pagebuilder->SkinName().'");
SearchForm.Show();
		');
		$this->_pagebuilder->_top->AddOnClick('SearchForm.checkVisibility(event, Browser.Mozilla);');
	}
	
	/**
	 * @return String
	 */
	function CreateGroupsHtml()
	{
		$out = '';
		$groupNames = &$this->_pagebuilder->_proc->db->SelectUserAddressGroupNames();
		foreach ($groupNames as $id => $name)
		{
			$out .= '<option value="'.$id.'">'.ConvertUtils::WMHtmlSpecialChars($name).'</option>';
		}
		return $out;
	}
	
	function ToHTML()
	{
		$text = (isset($this->_pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT])) ? $this->_pagebuilder->_proc->sArray[SEARCH_ARRAY][S_TEXT] : '';
		return '
<div class="wm_toolbar_search_item" style="margin-left: 0px;" id="search_control_div_down" >
	<span class="wm_toolbar_icon" style="background-position: -640px 0px;">&nbsp;</span>
</div>
<div class="wm_hide" style="margin-left: 0px;" id="search_control_div_up">
	<span class="wm_toolbar_icon" style="background-position: -680px 0px;">&nbsp;</span>
</div>
<div class="wm_toolbar_search_item" onmouseover="this.className=\'wm_toolbar_search_item_over\'" 
onmouseout="this.className=\'wm_toolbar_search_item\'" id="search_small_form" style="margin-right: 0px;">
	<form action="?'.S_GETMODECONTACT.'=mini" method="POST" id="searchformmini">
		<input type="text" id="smallLookFor" name="smallLookFor" class="wm_search_input" value="'.ConvertUtils::AttributeQuote($text).'" >
		<span class="wm_toolbar_icon" onclick="document.getElementById(\'searchformmini\').submit();"
			style="background-position: -560px 0px;">&nbsp;</span>
	</form>
</div>	
'.$this->_hidePart;
	}
	
	function ToHideDiv()
	{
		return '
<div class="wm_hide" id="search_form">
<form action="?'.S_GETMODECONTACT.'=big" method="POST" id="searchformbig">
	<table>
		<tr>
			<td class="wm_search_title">
				'.JS_LANG_LookFor.'
			</td>
			<td class="wm_search_value">
				<input type="text" id="bigLookFor" name="bigLookFor" class="wm_search_input" value="" />
				<span class="wm_toolbar_icon" onclick="document.getElementById(\'searchformbig\').submit();" style="background-position: -560px 0px;">&nbsp;</span>
			</td>
		</tr>
		<tr>
			<td class="wm_search_title">
				'.JS_LANG_SearchIn.'
			</td>
			<td class="wm_search_value">
				<select name="'.CONTACT_ID.'">
					<option value="-2" selected="selected">'.JS_LANG_AllGroups.'</option>
					'.
					$this->CreateGroupsHtml()
					.'
				</select>
			</td>
		</tr>
	</table>
</form>
</div>';
	}
	
} 
