/*
 * Classes:
 *  CMessagesListViewScreen
 */

function CreateMoveActionFunc(id, fullName)
{
	return function() { RequestMessagesOperationHandler(TOOLBAR_MOVE_TO_FOLDER, [], id, fullName) }
}

function CreateFolderClickFunc(id, fullName, obj, element)
{
	return function() {
		obj.FolderClick(id, fullName, element);
		return false;
	}
}

function CMessagesListViewScreen(skinName)
{
	this.Id = SCREEN_MESSAGES_LIST_VIEW;
	this.isBuilded = false;
	this.hasCopyright = false;
	this.BodyAutoOverflow = false;
	this.SearchFormId = 'search_form' + this.Id;
	this.shown = false;
	
	this._checkMail = new CCheckMail();
	this._spaceInfoObj = new CSpaceInfo();

	this._showTextLabels = true;
	this._allowContacts = true;
	this._isDisplayFolders = null;
	this._defaultFoldersWidth = 115;
	this._skinName = skinName;
	this._timeOffset = 0;
	this._defLang = '';
	this._messagesPerPage = 20;
	this.isDirectMode = false;
	this._useImapTrash = false;

	this._page = 1;
	this._lookForStr = '';
	this._searchMode = 0;
	this._folderId = -1;
	this._folderFullName = '';
	this._sortField = SORT_FIELD_DATE;
	this._sortOrder = SORT_ORDER_DESC;
	this._removeCount = 0;

	this._SEPARATOR = '#@%';
	this.Protocol = POP3_PROTOCOL;
	this.isInboxDirectMode = false;

	this._mainContainer = null;

	this.SearchFormObj = null;
	this._lookForSmallObj = null;
	this._bigSearchForm = null;
	this._lookForBigObj = null;
	this._searchButtonImg = null;
	this._searchIn = null;
	this._quickSearch = null;
	this._slowSearch = null;

	this._toolBar = null;
	this._pop3DeleteTool = null;
	this._reloadFoldersTool = null;
	this._imap4DeleteTool = null;
	this._markTool = null;
	this._moveTool = null;
	this._moveMenu = null;
	this._inboxMoveItem = null;
	this._isSpamTool = null;
	this._notSpamTool = null;

	this._foldersContainer = null;
	this._foldersHide = null;
	this._foldersHideImg = null;
	this._foldersList = null;
	this._manageFolders = null;
	this._foldersWidth = this._defaultFoldersWidth;
	this._minFoldersWidth = 5;
	this._foldersObj = null;
	this._foldersObjWait = null;//folders list, wich was update in manage folders, so it's necessary to fill it
	this._foldersParam = Array();
	this.InboxId = -1;
	this.InboxFullName = '';
	this.SentId = -1;
	this.SentFullName = '';
	this.DraftsId = -1;
	this.DraftsFullName = '';
	this.TrashId = -1;
	this.TrashFullName = '';
	this.SpamId = -1;
	this.SpamFullName = '';
	this._currFolder = null;

	this._vResizerCont = null;
	this._vertResizerObj = null;

	this._pageSwitcher = null;

	this._inboxContainer = null;
	this._inboxTable = null;
	this._fromToColumn = null;
	this._inboxLines = null;
	this._selection = new CSelection();
	this._dragNDrop = new CDragNDrop('Messages', 'msg_drop.gif', 'msg_not_drop.gif', skinName);
	this._dragNDrop.SetSelection(this._selection);
	this._inboxWidth = 361;

	this._messagesObj = null; // object CMessage, that is replaced in preview pane

	this._msgViewer = null;

	this.ShowPictures = function () {
		var msg = this._msgObj;
		if (msg.Safety != 1) {
			msg.ShowPictures();
			this._msgViewer.Fill(msg);
			this.ResizeScreen();
		}
	};

	this._picturesControl = new CMessagePicturesController(this.ShowPictures, this);
	this._showPicturesTbl = null;

	this._messageId = -1;
	this._messageUid = '';
	this._msgCharset = AUTOSELECT_CHARSET;
	this._msgObj = null;
	this.msgForView = null;
	this.forEditParams = [];
	this.fromDraftsParams = [];
	
	this._messagesInFolder = null;
	this._spaceInfo = null;
	this._spaceProgressBar = null;

	//logo + accountslist + toolbar + lowtoolbar
	this._externalHeight = 56 + 32 + 26 + 24;
	this._logo = null;
	this._accountsBar = null;
	this._lowToolBar = null;

	//manage folders + hide folders
	this._foldersExternalHeight = 22 + 20;
	this._foldersHeight = 100;
	this._foldersBordersHeight = 1;
	
	this._hResizerCont = null;
	this._hResizerHeight = 4;
	this._horizResizerObj = null;
	
	this._inboxHeight = 100;
	this._inboxHeadersHeight = 21;
	this._inboxAllBordersHeight = 3;
	//border + inbox headers
	this._defaultInboxHeight = 150;
	this._minUpper = 1 + this._inboxHeadersHeight;

	this._replyTool = null;
	this._forwardTool = null;

	this._messageHeadersHeight = 48;
	this._messagePadding = 16;
	this._minLower = 200;
	
	this.PlaceData = function(Data)
	{
		var Type = Data.Type;
		switch (Type) {
			case TYPE_FOLDERS_LIST:
				this.PlaceFoldersList(Data);
				break;
			case TYPE_MESSAGES_LIST:
				this.PlaceMessagesList(Data);
				break;
			case TYPE_MESSAGE:
				this._msgObj = Data;
				var id = Data.Id;
				var folderId = Data.FolderId;
				var folderFullName = Data.FolderFullName;
				var uid = Data.Uid;
				var charset = Data.Charset;
				if (null != this.msgForView && this.msgForView.Id == id && this.msgForView.Uid == uid &&
				 this.msgForView.FolderId == folderId && this.msgForView.FolderFullName == folderFullName &&
				 this.msgForView.Charset == charset) {
					SelectScreenHandler(SCREEN_VIEW_MESSAGE);
					this.msgForView = null;
				}
				this._messageId = id;
				this._messageUid = uid;
				this._msgCharset = charset;
				this.FillByMessage();
				break;
			case TYPE_MESSAGES_OPERATION:
				this.PlaceMessagesOperation(Data);
				break;
		}
	};
	
	this.GetCurrMessageHistoryObject = function ()
	{
		var historyObj = this.GetCurrFolderHistoryObject();
		historyObj.MsgId = this._messageId,
		historyObj.MsgUid = this._messageUid,
		historyObj.MsgFolderId = this._folderId,
		historyObj.MsgFolderFullName = this._folderFullName,
		historyObj.MsgCharset = this._msgCharset,
		historyObj.MsgParts = [PART_MESSAGE_HEADERS, PART_MESSAGE_HTML, PART_MESSAGE_ATTACHMENTS]
		return historyObj;
	};
	
	this.ResizeBody = function (mode)
	{
		if (this.isBuilded) {
			this.ResizeScreen(mode);
			if (!Browser.IE && mode == 'all') {
				this.ResizeScreen(mode);
			}
		}
	};
	
	this.ResizeScreen = function (mode)
	{
		if (mode == 'height')
			CreateCookie('wm_horiz_resizer', this._horizResizerObj._topPosition, COOKIE_STORAGE_DAYS);
		if (mode == 'width' && this._isDisplayFolders == true) {
			CreateCookie('wm_vert_resizer', this._vertResizerObj._leftPosition, COOKIE_STORAGE_DAYS);
		}
		var isAuto = false;
		var height = GetHeight();
		var innerHeight = height - this.GetExternalHeight();//logo, accountsBar, toolBar, lowToolBar
		if (innerHeight < 300) {
			innerHeight = 300;
			isAuto = true;
		}

		if (mode != 'width') {
			this._inboxHeight = this._horizResizerObj._topPosition - this._minUpper;
			this.ResizeFoldersHeight(innerHeight);
			this._vertResizerObj.updateVerticalSize(innerHeight);
			this.ResizeInboxHeight(innerHeight);
		}
		
		var foldersImgWidth = this._foldersHideImg.offsetWidth;
		if (foldersImgWidth < this._minFoldersWidth) foldersImgWidth = this._minFoldersWidth;
		var resizerWidth = this._vResizerCont.offsetWidth;
		if (resizerWidth == 0) resizerWidth = 4;
		var width = GetWidth();
		if (mode != 'height') {
			var fpWidth = (this._foldersWidth < foldersImgWidth) ? foldersImgWidth : this._foldersWidth;
			var validator = new CValidate();
			var leftPos = this._vertResizerObj._leftPosition;
			if (this._isDisplayFolders == true && validator.IsPositiveNumber(leftPos) && leftPos >= foldersImgWidth) {
				fpWidth = leftPos;
			}
			var ipWidth = width - fpWidth - resizerWidth;
			if (ipWidth < 550) {
				ipWidth = 550;
				fpWidth = width - ipWidth - resizerWidth;
				if (this._isDisplayFolders == true) {
					if (fpWidth < 80) {
						fpWidth = 80;
						isAuto = true;
					}
				}
				else {
					if (fpWidth < foldersImgWidth) {
						fpWidth = foldersImgWidth;
						isAuto = true;
					}
				}
			}
			else {
				fpWidth = width - ipWidth - resizerWidth;
			}
			this._foldersWidth = fpWidth;
			if (this._isDisplayFolders == true) this._defaultFoldersWidth = fpWidth;
			this.ResizeInboxContainerWidth(ipWidth);
			if (this._isDisplayFolders == true)
				this._vertResizerObj._leftPosition = fpWidth;
			this.ResizeFoldersWidth(fpWidth);
			this._horizResizerObj.updateHorizontalSize(ipWidth);
		}

		this.ResizeInboxWidth();
		if (mode != 'height') {
			this.ResizeMessageWidth();
		}
		else {
			this._msgViewer.ResizeWidth(this._inboxWidth - this._messageHorBordersWidth);
		}
		if (mode != 'width') {
			this.ResizeInboxHeight(innerHeight);
		}
		if (null != this._pageSwitcher) this._pageSwitcher.Replace(this._inboxLines);
		SetBodyAutoOverflow(isAuto);
		this._dragNDrop.Resize();
	};
	
	this.GetExternalHeight = function()
	{
		var x = this._logo.offsetHeight + this._accountsBar.offsetHeight + this._toolBar.table.offsetHeight + this._lowToolBar.offsetHeight;
		if (x != 0)
			this._externalHeight = x;
		return this._externalHeight;
	};
	
	this.ResizeFoldersHeight = function(height)
	{
		var validator = new CValidate();
		if (validator.IsPositiveNumber(height) && height >=100) {
			this._foldersHeight = height;
			var allHeight = this._foldersHeight - this._foldersBordersHeight;
			var externalHeight = this._foldersHide.offsetHeight + this._manageFolders.offsetHeight;
			if (externalHeight != 0)
				this._foldersExternalHeight = externalHeight;
			this._foldersContainer.style.height = allHeight + 'px';
			this._foldersList.style.height = (allHeight - this._foldersExternalHeight) + 'px';
		}
	};
	
	this.ResizeMessageWidth = function()
	{
		PreviewPaneMessageHeaders.Resize(this._inboxWidth - this._messageHorBordersWidth);
		this._msgViewer.ResizeWidth(this._inboxWidth - this._messageHorBordersWidth);
	};
	
	this.GetMessageExternalHeight = function()
	{
		var inboxHeight = this._inboxTable.GetHeight();
		var offsetHeight = this._hResizerCont.offsetHeight;
		if (offsetHeight) {
			this._hResizerHeight = offsetHeight;
		}
		offsetHeight = PreviewPaneMessageHeaders.GetHeight();
		if (offsetHeight) {
			this._messageHeadersHeight = offsetHeight;
		}
		offsetHeight = this._showPicturesTbl.offsetHeight;
		if (offsetHeight) {
			this._messageHeadersHeight += offsetHeight;
		}
		return inboxHeight + this._inboxAllBordersHeight + this._hResizerHeight + this._messageHeadersHeight;
	};
	
	this.ResizeInboxHeight = function(height)
	{
		var validator = new CValidate();
		if (validator.IsPositiveNumber(height) && height >=100) {
			var messInnerHeight = height - this.GetMessageExternalHeight();
			if (messInnerHeight < 100) {
				this._inboxHeight -= 100 - messInnerHeight;
				messInnerHeight = 100;
			};
			if (this._inboxHeight < 100) {
				this._inboxHeight = 100;
			};
			this._inboxTable.SetLinesHeight(this._inboxHeight);
			this._horizResizerObj._topPosition = this._inboxHeight + this._minUpper;
			this._msgViewer.ResizeHeight(messInnerHeight);
		}
	};

	this.ParseSettings = function (settings)
	{
		this._useImapTrash = settings.UseImapTrash;
		this._allowContacts = settings.AllowContacts;
		this._showTextLabels = settings.ShowTextLabels;
		this._spaceInfoObj.ParseSettings(settings);
		if (null == this._isDisplayFolders)
			this._isDisplayFolders = (settings.HideFolders) ? false : true;
		this._defaultInboxHeight = settings.HorizResizer;
		this._defaultFoldersWidth = settings.VertResizer;
		this.ChangeSkin(settings.DefSkin);
		if (this._timeOffset != settings.TimeOffset ||
		this._defLang != settings.DefLang ||
		this._messagesPerPage != settings.MsgsPerPage) {
			var page = this._page;
			if (this._messagesPerPage != settings.MsgsPerPage) {
				page = 1;
			}
			this._timeOffset = settings.TimeOffset;
			this._defLang = settings.DefLang;
			this._messagesPerPage = settings.MsgsPerPage;
			if (this.isBuilded && (this._folderId != -1 || this._folderFullName != '')) {
				SetHistoryHandler(
					{
						ScreenId: this.Id,
						FolderId: this._folderId,
						FolderFullName: this._folderFullName,
						Page: page,
						SortField: this._sortField,
						SortOrder: this._sortOrder,
						LookForStr: '',
						SearchMode: 0,
						RedrawType: REDRAW_NOTHING,
						RedrawObj: null,
						MsgId: null,
						MsgUid: null,
						MsgFolderId: null,
						MsgFolderFullName: null,
						MsgCharset: null,
						MsgParts: null,
						ForcedRequest: true
					}
				);
			}
			else {
				this.RedrawPages(this._page);
			}
		}
		else {
			this.RedrawPages(this._page);
		}
	};//ParseSettings
	
	this.ChangeSkin = function (newSkin)
	{
		if (this._skinName != newSkin) {
			this._skinName = newSkin;
			if (this.isBuilded) {
			    if (this._isDisplayFolders)
		            this._foldersHideImg.src = './skins/' + newSkin + '/folders/' + ((window.RTL) ? 'show_folders.gif' : 'hide_folders.gif');
				else
		            this._foldersHideImg.src = './skins/' + newSkin + '/folders/' + ((window.RTL) ? 'hide_folders.gif' : 'show_folders.gif');
				PreviewPaneMessageHeaders.ChangeSkin(newSkin);
				this.CleanFoldersList();
				this.FillByFolders();
				this._inboxTable.SetSort(this._sortField, this._sortOrder);
				this._inboxTable.ChangeSkin(newSkin);
				this.RedrawPages(this._page);
				this.FillByMessages();
			}
		}
	};
	
	this.Build = function(container, accountsBar, PopupMenus, settings)
	{
		this.ParseSettings(settings);
		this._logo = document.getElementById('logo');
		this._accountsBar = accountsBar;

		this._toolBar = new CToolBar(container);
		this.BuildAdvancedSearchForm();
		this.BuildToolBar(container, PopupMenus);

		var div = CreateChild(container, 'div');
		this._mainContainer = div;
		div.className = 'wm_hide';
		var tbl = CreateChild(div, 'table');
		tbl.className = 'wm_mail_container';
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);
		td.rowSpan = 3;
		this.BuildFoldersPart(td);

		td = tr.insertCell(1);
		td.rowSpan = 3;
		td.className = 'wm_vresizer_part';
		this._vResizerCont = td;
		var VResizer = CreateChild(td, 'div');
		VResizer.className = 'wm_vresizer';
		div = CreateChild(td, 'div');
		div.className = 'wm_vresizer_width';

		this._inboxContainer = tr.insertCell(2);
		var obj = this;
		this._inboxContainer.onmousedown = function (ev) {
			if (isRightClick(ev)) {
				obj._selection.UncheckAll();
			}
			return false;
		};
		this.BuildInboxTable();

		tr = tbl.insertRow(1);
		td = tr.insertCell(0);
		td.className = 'wm_hresizer_part';
		this._hResizerCont = td;
		div = CreateChild(td, 'div');
		div.className = 'wm_hresizer_height';
		var HResizer = CreateChild(td, 'div');
		HResizer.className = 'wm_hresizer';
		div = CreateChild(td, 'div');
		div.className = 'wm_hresizer_height';

		tr = tbl.insertRow(2);
		td = tr.insertCell(0);
		this.BuildMessageContainer(td);

		tr = tbl.insertRow(3);
		this._lowToolBar = tr.insertCell(0);
		this._lowToolBar.colSpan = 3;
		this._lowToolBar.className = 'wm_lowtoolbar';
		this._messagesInFolder = CreateChild(this._lowToolBar, 'span');
		this._messagesInFolder.className = 'wm_lowtoolbar_messages';
		this.WriteMsgsCountInFolder(0);

		this._spaceInfoObj.Build(this._lowToolBar, settings);

		this._vertResizerObj = new CVerticalResizer(VResizer, this._mainContainer, 2, 81, 551, this._defaultFoldersWidth, 'WebMail.ResizeBody(\'width\');');
		this._horizResizerObj = new CHorizontalResizer(HResizer, this._mainContainer, 2, this._minUpper + 100, this._minLower, this._defaultInboxHeight, 'WebMail.ResizeBody(\'height\');');
		if (this._isDisplayFolders == false)
			this._vertResizerObj.free();
		this.isBuilded = true;
	};//Build
	
	this.RedrawFolderControls = function (redrawElement, id, fullName)
	{
		if (redrawElement) {
			if (this._currFolder) this._currFolder.className = '';
			redrawElement.className = 'wm_select_folder';
			this._currFolder = redrawElement;
			this.CleanMessageBody(true);
		};
		if (id && fullName) {
			this.ChangeFolder(id, fullName);
		};
		if (id == -1 && fullName == '') {
			if (this._currFolder) this._currFolder.className = '';
			this.ChangeFolder(id, fullName);
		}
	};
	
	this.ChangeFolder = function (id, fullName)
	{
		this._folderId = id;
		this._folderFullName = fullName;
		this.CleanMessageBody(true);
		this._searchIn.value = this._folderId + this._SEPARATOR + this._folderFullName;
	};

	this.BuildToolBar = function (container, PopupMenus)
	{
		var obj = this;
		var toolbar = this._toolBar;
		//new message tool
		var item = toolbar.AddItem(TOOLBAR_NEW_MESSAGE, function () { SetHistoryHandler({ ScreenId: SCREEN_NEW_MESSAGE }); }, true);
		//check mail tool
		item = toolbar.AddItem(TOOLBAR_CHECK_MAIL, function () { obj._checkMail.Start(); }, true);
		//reload folders list tool; only imap
		this._reloadFoldersTool = toolbar.AddItem(TOOLBAR_RELOAD_FOLDERS, function () { GetFoldersListHandler(WebMail.Accounts.CurrId, 2); }, false);
		//reply tool (reply, reply all); absent in drafts
		this._replyTool = toolbar.AddReplyItem(PopupMenus, false);
		//forward tool; absent in drafts
		this._forwardTool = toolbar.AddItem(TOOLBAR_FORWARD, CreateReplyClick(TOOLBAR_FORWARD), false);
		//mark tool; absent in inbox in direct mode in pop3
		this._markTool = toolbar.AddMarkItem(PopupMenus, false);
		//move to folder tool; absent in inbox in direct mode in pop3
		var div = CreateChild(document.body, 'div');
		this._moveMenu = div;
		div.className = 'wm_hide';
		this._moveTool = toolbar.AddMoveItem(TOOLBAR_MOVE_TO_FOLDER, PopupMenus, div, false);
		//delete tools
		this._pop3DeleteTool = toolbar.AddPop3DeleteItem(PopupMenus, false);
		this._imap4DeleteTool = toolbar.AddImapDeleteItem(PopupMenus, false);
		// spam tools
		this._isSpamTool = toolbar.AddItem(TOOLBAR_IS_SPAM, function () { RequestMessagesOperationHandler(TOOLBAR_IS_SPAM, []); }, false);
		this._notSpamTool = toolbar.AddItem(TOOLBAR_NOT_SPAM, function () { RequestMessagesOperationHandler(TOOLBAR_NOT_SPAM, []); }, false);
		toolbar.AddLastItem();
		
		var searchParts = toolbar.AddSearchItems();
		this.SearchFormObj = new CSearchForm(this._bigSearchForm, searchParts.SmallForm, searchParts.DownButton.Cont, searchParts.UpButton.Cont, this.SearchFormId, this._lookForBigObj, searchParts.LookFor);
		if (null != this._searchIn) {
			this.SearchFormObj.SetSearchIn(this._searchIn);
		}
		this._lookForSmallObj = searchParts.LookFor;
		var obj = this;
		searchParts.LookFor.onkeypress = function (ev) {
			if (isEnter(ev)) {
				obj.GetSearchResultsFromSmall();
			}
		};
		searchParts.ActionImg.onclick = function () {
			obj.GetSearchResultsFromSmall();
		};
		toolbar.Hide();
	};
	
	this.CleanMessageBody = function (showInfo)
	{
		this._msgObj = null;
		PreviewPaneMessageHeaders.Clean();
		if (this._messagesObj != null && this._messagesObj.MessagesCount > 0 && showInfo) {
			this._msgViewer.Clean('<div class="wm_inbox_info_message">' + Lang.InfoNoMessageSelected + 
			'<br /><div class="wm_view_message_info">' + Lang.InfoSingleDoubleClick + '</div></div>');
		}
		else {
			this._msgViewer.Clean();
		}
		this._picturesControl.Hide();
		this.ResizeBody('all');
		this._msgObj = null;
	};
	
	this.FillByMessage = function()
	{
		var contactId = this._msgObj.FromContact.Id;
		var contact = this._msgObj.FromContact;
		if (contactId != -1) {
			var stringDataKey = WebMail.DataSource.GetStringDataKey(TYPE_CONTACT, {IdAddr: contactId});
			if (WebMail.DataSource.Cache.ExistsData(TYPE_CONTACT, stringDataKey)) {
				contact = WebMail.DataSource.Cache.GetData(TYPE_CONTACT, stringDataKey);
			}
		}
		PreviewPaneMessageHeaders.Fill(this._msgObj, contact);
		
		this._picturesControl.SetSafety(this._msgObj.Safety);
		switch (this._msgObj.Safety) {
			case 0:
				this._picturesControl.Show();
				var fromParts = GetEmailParts(HtmlDecode(this._msgObj.FromAddr));
				this._picturesControl.SetFromAddr(fromParts.Email);
			break;
			case 1:
				this._picturesControl.Hide();
			break;
			case 2:
				this._picturesControl.Show();
			break;
		}

		var htmlMode = this._msgViewer.Fill(this._msgObj);
		if (!htmlMode) this._picturesControl.Hide();
		this.ResizeBody('all');
		if (null != this._pageSwitcher) this._pageSwitcher.Replace(this._inboxLines);
	};

	this.SwitchToHtmlPlain = function ()
	{
		this._msgViewer.SwitchToHtmlPlain();
	};
	
	this.BuildMessageContainer = function(mainTd)
	{
		var obj = this;
		var div = CreateChild(mainTd, 'div');
		div.className = 'wm_message_container';
		if (this._messageHorBordersWidth == undefined) {
			var borders = GetBorders(div);
			this._messageHorBordersWidth = borders.Left + borders.Right;
		}
		
		var tbl = CreateChild(div, 'table');
		var tr = tbl.insertRow(0);
		var td = tr.insertCell(0);

		this._showPicturesTbl = this._picturesControl.Build(td);
		PreviewPaneMessageHeaders.Build(td, this._skinName);
		tr = tbl.insertRow(1);
		td = tr.insertCell(0);
		this._msgViewer = new CMessageViewer();
		this._msgViewer.Build(td, 0);
		this._msgViewer.SetSwitcher(PreviewPaneMessageHeaders.SwitcherCont, 'wm_message_right', PreviewPaneMessageHeaders.SwitcherObj);
	}
};

CMessagesListViewScreen.prototype = MessagesListPrototype;
